// ClientSocketReceiver.cpp

//

// See header for explanation

//

// Author : Masahiro Minami < elsur@aaa.letter.co.jp >

//



#ifdef macintosh



#include "ClientSocketReceiver.h"





ClientSocketReceiver::ClientSocketReceiver

	( int id, Socket* sockPtr, NetworkServerManager* netManPtr )

{

	socketID = id;

	socketPtr = sockPtr;

	netManagerPtr = netManPtr;

	

}



ClientSocketReceiver::~ClientSocketReceiver()

{

}



OSErr

ClientSocketReceiver::startReceiving()

{

	OSErr theErr = NewThread( kCooperativeThread, clientSocketReceiverProc,

		reinterpret_cast<void*>( this ), 0, 0, nil, &thread_id );

	

	return theErr;

}



Socket*

ClientSocketReceiver::getSocket()

{

	return socketPtr;

}



NetworkServerManager*

ClientSocketReceiver::getManager()

{

	return netManagerPtr;

}



int

ClientSocketReceiver::getID()

{

	return socketID;

}



pascal void* clientSocketReceiverProc( void* p )

{

	ClientSocketReceiver* target = (ClientSocketReceiver*)p;

	Socket* sock = target->getSocket();

	NetworkServerManager* manager = target->getManager();

	BOOL disconnected = false;

	while( ! disconnected )

	{

		GenericMessage *GenMes=new GenericMessage;



		*sock>>*GenMes;

		/* GenMes->Dump(std::cerr); -- AGAIN ??? -- */



		if(sock->isError()==TRUE)

		{

			Log::Warning("Socket error on RECIEVING, CLOSING connection");

			sock->Close();

			sock=NULL;

			disconnected = true;

			manager->freeID( target->getID());

		}



		/* We store the correct ID as it isn't sent over the net. */

		GenMes->ID=target->getID();



		/* Now we look for the correct queue where to add this type of Message. */

		/* A hash table or even a simple array will make miracles here. */

		Queue *tmp=manager->GetQueue(GenMes->Type);

		if(tmp!=NULL)

		{

			tmp->AddInMessage(GenMes);

		} 

		else

		{

			/* ERROR this is an unknown message type. */

			Log::Warning("Unknown Message Type"); 

		}

		

		::YieldToAnyThread();

	}	

}



#endif // macintosh