// ClientSocketReceiver.h

//

// Wrap class for Arianne client socket. Only for use with MacOS server.

//

// Implements MacOS Thread, receives data, add them to queue...

//

// It does what NetworkServerManager::loop() does about receiving data,

// except for listening for in coming connection [ TestForNewConnection()].

//

// Author : Masahiro Minami < elsur@aaa.letter.co.jp>



#ifdef macintosh



// MacOS interfaces

#include <Threads.h>

#include <OpenTransport.h>



// Arianne interfaces

#include "NetworkServerManager.h"

#include "Log.h"



// General interfaces

#include <iostream>



class ClientSocketReceiver

{

	public:

		int	socketID;

		

		ClientSocketReceiver( int id, Socket* sockPtr, NetworkServerManager* netManagerPtr );

		~ClientSocketReceiver();

		

		OSErr startReceiving();

		

		Socket* getSocket();

		NetworkServerManager* getManager();

		int getID();

		

	private:

		Socket* socketPtr;

		NetworkServerManager* netManagerPtr;

		ThreadID	thread_id;

		

};



// Thread entry proc

pascal void* clientSocketReceiverProc( void* netManagerPtr);



#endif // macintosh