// ClientSocketSender.cpp

//

// See header for explanation

//

// Author : Masahiro Minami < elsur@aaa.letter.co.jp >

//



#ifdef macintosh



#include "ClientSocketSender.h"



ClientSocketSender::ClientSocketSender

	( int id, Socket* sockPtr, NetworkServerManager* netManPtr )

{

	socketID = id;

	socketPtr = sockPtr;

	netManagerPtr = netManPtr;

	

}



ClientSocketSender::~ClientSocketSender()

{

}



OSErr

ClientSocketSender::startSending()

{

	OSErr theErr = NewThread( kCooperativeThread, clientSocketSenderProc,

		reinterpret_cast<void*>( this ), 0, 0, nil, &thread_id );

	

	return theErr;

}



Socket*

ClientSocketSender::getSocket()

{

	return socketPtr;

}



NetworkServerManager*

ClientSocketSender::getManager()

{

	return netManagerPtr;

}



int

ClientSocketSender::getID()

{

	return socketID;

}



pascal void* clientSocketSenderProc( void* p )

{

	ClientSocketSender* target = (ClientSocketSender*)p;

	Socket* sock = target->getSocket();

	NetworkServerManager* manager = target->getManager();

	BOOL disconnected = false;

	Uint32 socketID = target->getID();

	

	while( ! disconnected )

	{

		for(int i=0;i<manager->SizeQueues();i++)

		{

			GenericMessage *GenMes=manager->GetQueue(i)->GetOutMessage( socketID );

			if(GenMes!=NULL)

			{

				*sock<<*GenMes;



				if(sock->isError()==TRUE)

				{

					Log::Warning("Socket error on SENDING, CLOSING connection");

					sock->Close();

					sock=NULL;

					disconnected = true;

					manager->freeID( target->getID());

				}

			}

		} 

		::YieldToAnyThread();

	}	

}



#endif // macintosh