// ServerSocketReceiver.cpp
//
// See header for explanation
//
// Author : Masahiro Minami < elsur@aaa.letter.co.jp >
//

#ifdef macintosh

#include "ServerSocketReceiver.h"


ServerSocketReceiver::ServerSocketReceiver
	( NetworkManager* netManPtr )
{
	netManagerPtr = netManPtr;
	socketPtr = netManagerPtr->GetSocket();
	
}

ServerSocketReceiver::~ServerSocketReceiver()
{
}

OSErr
ServerSocketReceiver::startReceiving()
{
	OSErr theErr = NewThread( kCooperativeThread, serverSocketReceiverProc,
		reinterpret_cast<void*>( this ), 0, 0, nil, &(netManagerPtr->receiverID)/*&thread_id*/ );
	
	return theErr;
}

Socket*
ServerSocketReceiver::getSocket()
{
	return socketPtr;
}

NetworkManager*
ServerSocketReceiver::getManager()
{
	return netManagerPtr;
}

pascal void* serverSocketReceiverProc( void* p )
{
	ServerSocketReceiver* target = (ServerSocketReceiver*)p;
	Socket* sock = target->getSocket();
	NetworkManager* manager = target->getManager();
	BOOL disconnected = false;
	int retry = 0;
	
	while( ! disconnected )
	{
		GenericMessage *GenMes=new GenericMessage;

		*sock>>*GenMes;
		/* GenMes->Dump(std::cerr); -- AGAIN ??? -- */

		if(sock->isError()==TRUE)
		{
			if( retry == RETRY )
			{
				Log::Warning("Socket error on RECIEVING, CLOSING connection");
				sock->Close();
				sock=NULL;
				disconnected = true;
			}
			else
				retry++;
		}
		else
		{
			/* Now we look for the correct queue where to add this type of Message. */
			/* A hash table or even a simple array will make miracles here. */
			Queue *tmp=manager->GetQueue(GenMes->Type);
			if(tmp!=NULL)
			{
				tmp->AddInMessage(GenMes);
			} 
			else
			{
				/* ERROR this is an unknown message type. */
				Log::Warning("Unknown Message Type"); 
			}
			retry = 0;
		}
		long cur = SDL_GetTicks();
		while( cur + 50 < SDL_GetTicks())	
			::YieldToAnyThread();
	}	
}

#endif // macintosh