// ServerSocketReceiver.h
//
// Wrap class for Arianne server socket. Only for use with MacOS client.
//
// Implements MacOS Thread, receives data, add them to queue...
//
// It does what NetworkManager::loop() does about receiving data.
//
// Author : Masahiro Minami < elsur@aaa.letter.co.jp>

#ifdef macintosh

// MacOS interfaces
#include <Threads.h>
#include <OpenTransport.h>

// Arianne interfaces
#ifndef ARIANNE_NetworkManager_H
#include "../common/NetworkManager.h"
#endif
#include "../common/Log.h"

// General interfaces
#include <iostream>

#define RETRY	3

class ServerSocketReceiver
{
	public:
		ServerSocketReceiver( NetworkManager* netManagerPtr );
		~ServerSocketReceiver();
		
		OSErr startReceiving();
		
		Socket* getSocket();
		NetworkManager* getManager();
	private:
		Socket* socketPtr;
		NetworkManager* netManagerPtr;
		ThreadID	thread_id;
		
};

// Thread entry proc
pascal void* serverSocketReceiverProc( void* netManagerPtr);

#endif // macintosh