// ServerSocketSender.cpp
//
// See header for explanation
//
// Author : Masahiro Minami < elsur@aaa.letter.co.jp >
//

#ifdef macintosh

#include "ServerSocketSender.h"

ServerSocketSender::ServerSocketSender
	( NetworkManager* netManPtr )
{
	netManagerPtr = netManPtr;
	serversocketPtr = netManagerPtr->GetSocket();
}

ServerSocketSender::~ServerSocketSender()
{
}

OSErr
ServerSocketSender::startSending()
{
	OSErr theErr = NewThread( kCooperativeThread, serverSocketSenderProc,
		reinterpret_cast<void*>( this ), 0, 0, nil, &(netManagerPtr->senderID)/*&thread_id*/ );
	
	return theErr;
}

Socket*
ServerSocketSender::getSocket()
{
	return serversocketPtr;
}

NetworkManager*
ServerSocketSender::getManager()
{
	return netManagerPtr;
}

pascal void* serverSocketSenderProc( void* p )
{
	ServerSocketSender* target = (ServerSocketSender*)p;
	Socket* sock = target->getSocket();
	NetworkManager* manager = target->getManager();
	BOOL disconnected = false;
	
	while( ! disconnected )
	{
		for(int i=0;i<manager->SizeQueues();i++)
		{
			GenericMessage *GenMes=manager->GetQueue(i)->GetOutMessage();
			if(GenMes!=NULL)
			{
				*sock<<*GenMes;

				if(sock->isError()==TRUE)
				{
					Log::Warning("Socket error on SENDING, CLOSING connection");
					sock->Close();
					sock=NULL;
					disconnected = true;
				}
			}
		} 
		::YieldToAnyThread();
	}	
}

#endif // macintosh