// ServerSocketSender.h
//
// Wrap class for Arianne server socket. Only for use with MacOS client.
//
// Implements MacOS Thread, receives data, add them to queue...
//
// It does what NetworkManager::loop() does about sending data.
//
// Author : Masahiro Minami < elsur@aaa.letter.co.jp>

#ifdef macintosh
#ifndef SERVER_SOCKET_SENDER
#define SERVER_SOCKET_SENDER

// MacOS interfaces
#include <Threads.h>
#include <OpenTransport.h>

// Arianne interfaces
#ifndef ARIANNE_NetworkManager_H
#include "../common/NetworkManager.h"
#endif
#include "../common/Log.h"

// General interfaces
#include <iostream>

class ServerSocketSender
{
	public:
		ServerSocketSender( NetworkManager* netManagerPtr );
		~ServerSocketSender();
		
		OSErr startSending();
		
		Socket* getSocket();
		NetworkManager* getManager();
		int getID();
		
	private:
		Socket* serversocketPtr;
		NetworkManager* netManagerPtr;
		ThreadID	thread_id;
		
};

// Thread entry proc
pascal void* serverSocketSenderProc( void* netManagerPtr);

#endif SERVER_SOCKET_SENDER
#endif // macintosh