/***************************************************************************
                          audio.h  -  description
                             -------------------
    begin                : Sun Sep 17 2000
    copyright            : (C) 2000 by Erik Unemyr
    email                : unemyr@hem.passagen.se
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
	Instructions for using this class:
	
	1. Include the Audio.h file in your source file (no shit).

	2. Add the desired audio commands in your source file.

			//Open the Audio Device
			Audio *audio = new Audio();

			//Set Music and Audio Volume
		 	audio->setAudioVolume(32); (Audio volume from 0-128)
			audio->setMusicVolume(32); (Music volume from 0-128)

			//Play .IT Music File
		 	audio->playMusicFile("file.it");

			Play .WAV Audio File
		 	audio->playAudioFile("file.wav");

	3. SDL and SDL_mixer must be linked while compiling.

****************************************************************************/
#ifndef __ARIANNE_AUDIO_H
#define __ARIANNE_AUDIO_H

//External Header Declarations
#include <SDL/SDL_mixer.h>
#include "../common/general.h"

//Audio class declaration
class Audio
{
	public:
		Audio();
	  	~Audio();
		void playAudioFile (const char *file, BOOL Loop);
		void playMusicFile (const char *file, BOOL Loop);
		void setAudioVolume (Uint32 audiovolume);
		void setMusicVolume (Uint32 musicvolume);

	private:
		Uint16 audio_open;
		Mix_Music *music;
		Mix_Chunk *wave;
};

#endif
