/***************************************************************************
    copyright            : (C) 2000 by Colby "WireWolf"
    email                : 
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This class represent a GUI.
    It is outdate.
***************************************************************************/
#include "../common/general.h"
#include "../common/Screen.h"
#include "../common/DataLoader.h"
#include "../common/Log.h"
#include "GUI.h"
#include "Font.h"

int hplevel = 100;
int mplevel = 100;

void GUI::LoadGUI()
{
	Log::Debug("Loading GUI.");
	//other code will go here eventually
}

void GUI::GameGUI()
{
	/* Load BMP and cause problems if not there */
	SDL_Surface *gui;
	gui = SDL_LoadBMP("./gfx/gui/int1.bmp");
	if(gui==NULL){
		Log::Error("Image not found");
		exit(0);
	}

	int posx = DataLoader::GetWidth() - 260;
	int posy = 10;
	
	SDL_Rect dest;
	dest.x = posx;
	dest.y = posy;
	dest.h = gui->h;
	dest.w = gui->w;

	SDL_SetColorKey(gui,SDL_SRCCOLORKEY,SDL_MapRGB(gui->format,0,0,0));
	SDL_BlitSurface(gui, NULL, Screen::GetScreen(), &dest);

	/* Do this to show that the meter works till I get a function to give hp and mp */
	if(hplevel > 0) hplevel--;
	if(mplevel > 0) mplevel--;
	
	/* This keeps the levels within ranges then draws them */
	while(hplevel > 100) hplevel--;
	while(hplevel < 0) hplevel++;
	while(mplevel > 100) mplevel--;
	while(mplevel < 0) mplevel++;
	GUI::MakeMeter(hplevel, 37, 15, "./gfx/gui/redmeter.bmp");
	GUI::MakeMeter(mplevel, 15, 15, "./gfx/gui/bluemeter.bmp");
}



/*********************************************************************
 *  The following code creates the Health and Magic meters shown in  *
 *  the game play screen.  value is the amount in %, fromx is the    *
 *  distance in pixels from the  right side of the screen, fromy is  *
 *  the distance in  pixels form the bottom of the screen, and file  *
 *  is a 200 x 12 bitmap.                                            *
 *********************************************************************/
void GUI::MakeMeter(int value, int fromx, int fromy, const char *file)
{
	/* Load BMP and cause problems if not there */
	SDL_Surface *meter;
	meter = SDL_LoadBMP(file);
	if(meter==NULL){
		Log::Error("Image not found");
		exit(0);
	}

	/* Do a bit of math */
	int posx = DataLoader::GetWidth() - fromx - meter->w;
	int posy = DataLoader::GetHeight() - fromy - meter->h + (meter->h/2 - value);

	SDL_Rect dest;
	dest.x = posx;
	dest.y = posy;
	dest.h = meter->h;
	dest.w = meter->w;

	/* Define the area to be shown */
	int top = DataLoader::GetHeight() - fromy - meter->h/2;
	int bottom = DataLoader::GetHeight() - fromy;
	int left = posx;
	int right = posx + meter->w;

    #ifndef I_HAVE_SDL_1_1_6
//	SDL_SetClipping(meter, top, left, bottom, right); 
    #else
    #endif

	SDL_BlitSurface(meter, NULL, Screen::GetScreen(), &dest);	
}
