#ifndef __ARIANNE_RPG_Renderer_h
#define __ARIANNE_RPG_Renderer_h

#include "../common/general.h"
#include "../common/GFXData.h"
#include "../common/Object.h"
#include "../common/World.h"
#include "../common/astring.h"
#include "Font.h"

typedef struct PLAYER_SCREEN_POSITION
  {
  Object *Player;
  Uint16 x;
  Uint16 y;
  }
  PLAYER_SCREEN_POSITION;

/**
This class take the Map info and make it graphical representation of it,
**/
class Renderer
  {
  static GFXData *Logo;
  static GFXData **Tiles;
  static GFXData **Terrains;
  static PLAYER_SCREEN_POSITION *PlayerScreenPos;

  public:
  /** This method load all the data needed by the renderer */
  static int LoadData();

  /** This method is called each time the data in the world is modified */
  static void Update(Object *object,World *world,Uint32 actualframe=0,Uint32 lastframe=0);

  /** This method renders the actual game state to the screen. */
  static void Show(Object *object,World *world,Uint32 actualframe,Uint32 lastframe);

  /** Trying to mimic the OpenGL way */
  static void Begin();

  /** Trying to mimic the OpenGL way. */
  static void End();

  /** This method returns the player actual coordinates in screen. */
  static void GetPlayerPos(Object *Player,Uint16 *x,Uint16 *y);

  };

#endif