/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This an abstraction of a common Uint32 variable.
***************************************************************************/
#include "AUint32.h"

AUint32::AUint32()
  {
  value=0;
  }

AUint32::AUint32(Uint32 tmp)
  {
  value=tmp;
  }

AUint32::operator Uint32(void)
  {
  return value;
  }

int AUint32::operator=(Uint32 newvalue)
  {
  return value=newvalue;
  }

Uint32 AUint32::GetSize()
  {
  return sizeof(Uint32);
  }

void AUint32::ToVector(AVector *Vector)
  {
  assert(Vector!=NULL);

  AVector *tmp=new AVector();
  tmp->SetVectorSize(GetSize());

  Uint8 Word[4];
  SDLNet_Write32(value,Word);
  tmp->AddUint8(Word,GetSize());

  (*Vector)+tmp;
  delete tmp;
  }

void AUint32::FromVector(AVector* data)
  {
  assert(data!=NULL);

  Uint8 Word[4];
  data->GetUint8(Word,GetSize());
  value=SDLNet_Read32(Word);
  }