/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This an abstraction of a common Action.

    All the actions are translated to this generic actions.
***************************************************************************/
#include "Action.h"
#include "general.h"

Action::Action()
  {
  Data=new AVector;
  }

Action::~Action()
  {
  if(Data)
    {
    delete Data;
    Data=0;
    }
  }

/**
Returns the size of the whole Action object when written in a vector.
**/
Uint16 Action::GetSize()
  {
  assert(Data!=NULL);

  return TypeAction.GetSize()+SourceID.GetSize()+TargetID.GetSize()+x.GetSize()+y.GetSize()+z.GetSize()+Data->GetSize()+4;
  }

Uint16 Action::GetType()
  {
  return (Uint16)TypeAction;
  }

/**
This creates the vector with the data of the class.
**/
void Action::ToVector(AVector *Vector)
  {
  assert(Vector!=NULL);

  TypeAction.ToVector(Vector);
  SourceID.ToVector(Vector);
  TargetID.ToVector(Vector);
  x.ToVector(Vector);
  y.ToVector(Vector);
  z.ToVector(Vector);

  Data->ToVector(Vector);
  }

void Action::FromVector(AVector *Vector)
  {
  assert(Vector!=NULL);

  TypeAction.FromVector(Vector);
  SourceID.FromVector(Vector);
  TargetID.FromVector(Vector);
  x.FromVector(Vector);
  y.FromVector(Vector);
  z.FromVector(Vector);

  if(Data)
    {
    delete Data;    
    }
  Data=new AVector();
 
  Data->FromVector(Vector);
  }

void Action::XYZFromPos(Position *Pos)
  {
  assert(Pos!=NULL);
   
  Uint32 tmpx,tmpy,tmpz;
  Pos->GetXYZ(&tmpx,&tmpy,&tmpz);
  z=tmpz;
  y=tmpy;
  x=tmpx;
  }
