#include "Bzip2Support.h"
#include "Log.h"

void Bzip2Support::Begin()
  {
  incoming.next_in = NULL;
  incoming.avail_in = 0;

  incoming.bzalloc = NULL;
  incoming.bzfree = NULL;
  incoming.opaque = NULL;
  
  outgoing.bzalloc = NULL;
  outgoing.bzfree = NULL;
  outgoing.opaque = NULL;
  
  BZ2_bzCompressInit(&outgoing,1,0,0);
  BZ2_bzDecompressInit(&incoming,0,0);
  }
  
void Bzip2Support::End()
  {
  BZ2_bzCompressEnd(&outgoing);
  BZ2_bzDecompressEnd(&incoming);
  }
    
AVector *Bzip2Support::Encode(AVector *vector)
  {
  assert(vector!=NULL);
   
  AVector *out=new AVector;
  Sint32 status;

  char *Buffer=new char[BUFFER_SIZE];
  
  outgoing.next_in=(char*)(vector->Get());
  outgoing.avail_in=vector->GetVectorSize();

  do 
    {       
	outgoing.next_out=Buffer;
	outgoing.avail_out=BUFFER_SIZE;	  
	  
	status=BZ2_bzCompress(&outgoing,BZ_FINISH);
    	  
	if(status<0)
      {
      /* An error has ocurred. */
      Log::Error("Bzip2 Error Compressing");
      }

    AVector *tmp=new AVector();
    tmp->SetVectorSize(BUFFER_SIZE-outgoing.avail_out);
    tmp->AddUint8((Uint8*)Buffer,tmp->GetVectorSize());
	(*out)+tmp;	  
    delete tmp;
    } 
  while (outgoing.avail_out==0);

  delete Buffer;
    
  return out;
  }
    
AVector *Bzip2Support::Decode(AVector *vector)
  {
  assert(vector!=NULL);
   
  AVector *out=new AVector;
  Sint32 status;

 char *Buffer=new char[BUFFER_SIZE];

  incoming.next_in=(char*)(vector->Get());
  incoming.avail_in=vector->GetVectorSize();

  do 
    {
	incoming.next_out=Buffer;
	incoming.avail_out=BUFFER_SIZE;
	  
	status=BZ2_bzDecompress(&incoming);

	if(status<BZ_OK)
      {
      /* An error has ocurred. */
      Log::Error("Bzip2 Error Decompressing");
      }

    AVector *tmp=new AVector();
    tmp->SetVectorSize(BUFFER_SIZE-incoming.avail_out);
    tmp->AddUint8((Uint8*)Buffer,tmp->GetVectorSize());
	(*out)+tmp;	  
    delete tmp;
    } 
  while(incoming.avail_out==0);

  delete Buffer;

  return out;
  }
