/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This class load all the basic data from a INI like file
***************************************************************************/
#include "DataLoader.h"
#include "settings.h"
#include "FilePath.h"
#include "Log.h"
#include <cstring>

AString DataLoader::Filename;

void DataLoader::Init(char const* File)
  {
  Filename=File;

  FilePath path( Filename );
  path.getValidFilePath( Filename );

  FILE *Handle=fopen(Filename,"rb");
  if(Handle==NULL)
    {
    Log::Error("Initial configuration file not found.");
    }
  fclose(Handle);
  }

AString DataLoader::GetCharacterName()
  {
  PersistentString Name(Filename,"Game","CharacterName");
  return AString((char const*)Name);
  }

AString DataLoader::GetCharacterPassword()
  {
  PersistentString Password(Filename,"Game","Password");
  return AString((char const*)Password);
  }

AString DataLoader::GetHostName()
  {
  PersistentString HostName(Filename,"Host_info","HostName");
  return AString((char const*)HostName);
  }

Uint16 DataLoader::GetHostPort()
  {
  PersistentInt HostPort(Filename,"Host_info","HostPort");
  return HostPort;
  }

AString DataLoader::GetProxyName()
  {
  PersistentString ProxyName(Filename,"Proxy_support","ProxyName");
  return AString((char const*)ProxyName);
  }

Uint16 DataLoader::GetProxyPort()
  {
  PersistentInt ProxyPort(Filename,"Proxy_support","ProxyPort");
  return ProxyPort;
  }

Uint16 DataLoader::GetUseProxy()
  {
  PersistentInt UseProxy(Filename,"Proxy_support","UseProxy");
  return UseProxy;
  }


Uint32 DataLoader::GetTimeout()
  {
  PersistentInt TimedOut(Filename,"General","TimeOut");
  return TimedOut;
  }

AString DataLoader::GetReportFile()
  {
  PersistentString ReportFile(Filename,"File","ReportFile");
  return AString((char const*)ReportFile);
  }

AString DataLoader::GetReportHTMLFile()
  {
  PersistentString ReportFile(Filename,"File","ReportHTMLFile");
  return AString((char const*)ReportFile);
  }

AString DataLoader::GetErrorsFile()
  {
  PersistentString ErrorFile(Filename,"File","ErrorFile");
  return AString((char const*)ErrorFile);
  }

void DataLoader::SetCharacterName(char *tmp)
  {
  PersistentString Name(Filename,"Game","CharacterName");
  Name=tmp;
  Name.Flush();
  }

void DataLoader::SetCharacterPassword(char *tmp)
  {
  PersistentString Password(Filename,"Game","Password");
  Password=tmp;
  Password.Flush();
  }

void DataLoader::SetHostName(char *tmp)
  {
  PersistentString HostName(Filename,"Host_info","HostName");
  HostName=tmp;
  HostName.Flush();
  }

void DataLoader::SetHostPort(Uint16 tmp)
  {
  PersistentInt HostPort(Filename,"Host_info","HostPort");
  HostPort=tmp;
  HostPort.Flush();
  }
 
void DataLoader::SetTimeout(Uint32 tmp)
  {
  PersistentInt TimeOut(Filename,"General","TimeOut");
  TimeOut=tmp;
  TimeOut.Flush();
  }

Uint16 DataLoader::GetWidth()
  {
  PersistentInt Width(Filename,"Screen","Width");
  return Width;
  }

Uint16 DataLoader::GetHeight()
  {
  PersistentInt Height(Filename,"Screen","Height");
  return Height;
  }

Uint8 DataLoader::GetDepth()
  {
  PersistentInt Depth(Filename,"Screen","Depth");
  return Depth;
  }

BOOL DataLoader::GetFullscreen()
  {
  PersistentInt Fullscreen(Filename,"Screen","Fullscreen");
  return (Fullscreen==0)?FALSE:TRUE;
  }

