#ifndef ARIANNE_EventProcessor_h
#define ARIANNE_EventProcessor_h

#include "general.h"

#include "GUI/AppBase.h"

/**
This class is the one that manage all the events that SDL produce.
**/
class EventProcessor
  {
  Uint16 MouseX;
  Uint16 MouseY;
  Uint8 Button;

  Uint8 *KeyboardStatus;
  Uint16 *KeyBuffer;
  Uint8 iKeyBufferEnd;
  Uint8 iKeyBufferInit;

  AppBase* commander;

  public:
  EventProcessor();
  ~EventProcessor();
	
  BOOL Process();
  BOOL isKeyPressed(Uint16 key);
  Uint16 GetUnicodeKey();
  void ClearUnicodeBuffer();
  void GetMouseState(Uint16 *x,Uint16 *y, Uint8 *button);

  void setEventHandler( AppBase* commander );
    
  protected:	
  void keyDown(SDL_Event *event);
  void keyUp(SDL_Event *event);
  void mouseMotion(SDL_Event *event);
  void mouseButtonDown(SDL_Event *event);
  void mouseButtonUp(SDL_Event *event);
  
  };

#endif
