// FilePath.h
//
// Sub-class of AString
// Take Unix file path as constructor argument.
// Converts it to platform dependent file path.
//
// Currently meaningful for MacOS only.
//
// author: Masahiro Minami <elsur@aaa.letter.co.jp>
//

#ifndef FILE_PATH
#define FILE_PATH

#include "astring.h"

/**
This class convert a File path into a portable file path 
**/
class FilePath : public AString
{
	public:
		FilePath( AString& original );
		FilePath( const char* initValue = NULL );
		~FilePath();
		
		void  setPathLength( int len );
		int	  getPathLength();
		void  setPath( const char* newPath );
		char* getValidFilePath();
		void  getValidFilePath( char* outStr );
		void  getValidFilePath( AString& outAString );
		char* getOriginalPathStr();
		static const char PERIOD, UNIX_SEPARATOR, MAC_SEPARATOR;
		
	private:
		int pathLength;
};

#endif