#ifndef ARIANNE_GFXData_H 
#define ARIANNE_GFXData_H

#include "general.h"
#include "astring.h"
#include "Screen.h"

/* This is a sprite  -- For 2D Client -- */
class GFXData
  {
  /* This show how many anims and how long are them */
  Uint16 NumAnimations;
  Uint8 *NumFrames;

  Uint8 ActualFrame;
  float ToChange;
  BOOL isKeyColor;
  
  SDL_Surface ***Image;

  public:

  GFXData();
  ~GFXData();

  void GetSize(Uint16 *w,Uint16 *h);

  /** Call it to enable the use of transparent tiles. */
  void ToggleKeyColorOn();

  /** Set the number of animations that the tile is going to have */
  void SetNumAnimations(int NumAnims);

  /** Set the number of frames that each animation in the tile is going to have */
  void SetNumFrames(int NumAnim,int NumFrames);

  /** Load the frames for a given Anim from Disk */
  void LoadFrames(AString BaseFilename,int Anim);

  /** Show the given anim at position (x,y) on the screen, using time to choose key*/
  void Show(int x,int y,int Animation,Uint32 actualtime,Uint32 lasttime,SDL_Surface *ShowScreen=Screen::GetGameScreen());

  /** Show the given anim at position (x,y) on the screen, key choosen. */
  void Show(int x,int y,int Animation,int key,SDL_Surface *ShowScreen=Screen::GetGameScreen());
  };

#endif