#ifndef AWINDOW_H
#define AWINDOW_H

#include "../general.h"
#include "AWidget.h"

class AppBase;

#define MOUSE_FOCUS			1
#define KEY_FOCUS			2
#define MOUSE_AND_KEY_FOCUS	3

class AWindow : public AWidget
{
	public:
	
	AWindow( SDL_Surface* surface );
	AWindow( AString filepath );
	~AWindow();
	
	int			getWindowID();
	void		setWindowID( int num );
	
	virtual int		addWidget( AWidget* window, int x, int y );
	virtual void	removeWidget( AWidget* window );
	
	virtual BOOL	handleMouseDown( SDL_Event* e );
	virtual BOOL	handleMouseMove( SDL_Event* e );
	virtual BOOL	handleMouseUp( SDL_Event* e );

	void			close();		// Close the window ( destroy )
	
	private:
	
	AppBase*	application;
	int			windowID;
	int			lastMouseX, lastMouseY;
	BOOL		dragging;
};
#endif