/***************************************************************************
    copyright            : (C) 2000 by Masahiro Minami
    email                : elsur@aaa.letter.co.jp
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "AnimatingIcon.h"
#include "../FilePath.h"
#include "../Log.h"

AnimatingIcon::AnimatingIcon( AString filepath)
	: AnimatingWidget( filepath )
{
	frames = new SDL_Surface*[5];
	for( int i = 0; i < 5; i++)
		frames[i] = NULL;
	numFrames = curFrame = 1;
	frames[0] = surface;
	SDL_SetColorKey( surface, SDL_SRCCOLORKEY,SDL_MapRGB( surface->format, 0, 0, 0 ));
}

AnimatingIcon::~AnimatingIcon()
{
	for( int i = 0; i < numFrames; i++)
		if( frames[i] )
			SDL_FreeSurface( frames[i] );
}

void
AnimatingIcon::addFrame( AString filepath )
{
	if( numFrames < 5 )
	{
		numFrames++;
		FilePath path( filepath );
		path.getValidFilePath( filepath );
		SDL_Surface *tmp = SDL_LoadBMP( filepath );
        if(tmp==NULL)
          {
          Log::Error("Can't open file: %s",(char const*)filepath);
          }

		if( tmp )
			SDL_SetColorKey(tmp, 
				SDL_SRCCOLORKEY,SDL_MapRGB( tmp->format, 0, 0, 0 ));

        frames[numFrames - 1 ]=SDL_DisplayFormat(tmp);
        SDL_FreeSurface(tmp);

	}
}
void
AnimatingIcon::animate()
{
	curFrame ++;
	if( curFrame > numFrames )
		curFrame = 1;
	if( frames[curFrame - 1 ] )
	{
		surface = frames[curFrame - 1];
		requestUpdate( &partRect );
	}
}
