#ifndef APPBASE_H
#define APPBASE_H

#include "../general.h"
#include "../List.h"
#include "../AList.h"
#include "UTIL/GUIAnimator.h"

#include "AWindow.h"

class
AppBase : public AWindow
{
	public:
	
	static AppBase* CurrentApp;		// Holds the reference to the current application
									// Might be usefull ;)
	
	BOOL	done;
	
	AppBase( SDL_Surface* surface );
	~AppBase();
	
	virtual int		eventLoop();
	virtual int		eventLoop( int numEvents );
	virtual int		addWindow( AWindow* window, int x, int y );
	virtual void	removeWindow( AWindow* window );
	virtual void	setFrontWindow( AWindow* window );
	virtual AWindow* getFrontWindow();
	// Event handling functions. Inherited.
//	virtual BOOL	handleCommand( SDL_Event* e );
/*	virtual BOOL	handleMouseDown( SDL_Event* e );
	virtual BOOL	handleMouseMove( SDL_Event* e );
	virtual BOOL	handleMouseUp( SDL_Event* e );
	virtual BOOL	handleKeyDown( SDL_Event* e );
	virtual BOOL	handleKeyUp( SDL_Event* e );*/
	
	virtual BOOL	animate();
	
	AWindow*		findWindowAt( int x, int y );
	BOOL			requestFocus( int windowID , int focusType = MOUSE_FOCUS );
	
	void			addAnimator( GUIAnimator* animator );
	
	private:
	
	int				mouseFocusWindowID, keyFocusWindowID;
	AList<GUIAnimator>*		animatorList;
//	LIST*			windowsList;
};

#endif // APPBASE_H