/***************************************************************************
    copyright            : (C) 2000 by Masahiro Minami
    email                : elsur@aaa.letter.co.jp
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "../general.h"
#include "GUIShape.h"
#include "../Screen.h"

#include "../FilePath.h"

GUIShape::GUIShape( SDL_Surface* surface, GUIPart* parent )
	: GUIPart( surface, parent )
{
		SDL_SetColorKey( surface, SDL_SRCCOLORKEY,SDL_MapRGB( surface->format, 0, 0, 0 ));
}

GUIShape::GUIShape( AString filename, GUIPart* parent )
	: GUIPart( filename, parent )
{
		SDL_SetColorKey( getSurface(), SDL_SRCCOLORKEY,SDL_MapRGB( getSurface()->format, 0, 0, 0 ));
}

GUIShape::~GUIShape()
{
}

//	Virtual functions.

// Function to determin if the specified point ( ptx, pty ) is inside of
// the ( clickable, almost in any case, I think ) area.
// Default behavior suppose the GUI part is a simple rectangle.
// Override this function for a much complicated shape.
//
// IMPORTANT:
// ptx and pty are supposed to be globally coordinated.
BOOL
GUIShape::ptInPart( int ptx, int pty )
{
	Uint8* bits;
	ptx -= getRectRef()->x;
	pty -= getRectRef()->y;
	bits = ((Uint8*)getSurface()->pixels) + pty*getSurface()->pitch
		+ ptx * getSurface()->format->BytesPerPixel;
	return bits != 0;
}
