#ifndef LABEL_H
#define LABEL_H

#include "../general.h"
#include "../FilePath.h"
#include "GUIPart.h"

#ifdef USE_SDL_TTF
  #include "SDL_ttf.h"
  #include "freetype.h"
#else
  #include "../../client/Font.h"
#endif // USE_SDL_TTF

class
Label : public GUIPart
{
	public:
	Label( AString bkgrd_filepath, const char* text );
	~Label();
	
	virtual void	draw( SDL_Rect* localClip, SDL_Rect* globalClip );
	
	void			setText( const char* text );
	void			getText( char* outText );
	#ifdef USE_SDL_TTF
	void			setFont( TTF_Font* font );
	TTF_Font*		getFont();
	#else
	BitmapFont*		getFont();
	#endif // USE_SDL_TTF
	void			setFont( AString filepath );
	void			setColor( SDL_Color* color );
	SDL_Color*		getColor();
	
	private:
	
	char*			text;
	SDL_Color		color;
#ifdef USE_SDL_TTF
	TTF_Font*		font;
#else
	BitmapFont*		font;
#endif // USE_SDL_TTF
	
	private:
	
	SDL_Surface*	labelSurface;		// holds text surface. will be rendered over background
	void			resetText();
	
};

#endif