/***************************************************************************
    copyright            : (C) 2000 by Masahiro Minami
    email                : elsur@aaa.letter.co.jp
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "../general.h"
#include "../Screen.h"
#include "ShapedWindow.h"
#include "AppBase.h"

ShapedWindow::ShapedWindow( SDL_Surface* surface )
	: AWindow( surface )
{
	SDL_SetColorKey( surface, SDL_SRCCOLORKEY,SDL_MapRGB( surface->format, 0, 0, 0 ));
}

ShapedWindow::ShapedWindow( AString filepath )
	: AWindow( filepath )
{
	SDL_SetColorKey( surface, SDL_SRCCOLORKEY,SDL_MapRGB( surface->format, 0, 0, 0 ));
}

ShapedWindow::~ShapedWindow()
{
}

//	Virtual functions.

// Function to determin if the specified point ( ptx, pty ) is inside of
// the ( clickable, almost in any case, I think ) area.
// Default behavior suppose the GUI part is a simple rectangle.
// Override this function for a much complicated shape.
//
// IMPORTANT:
// ptx and pty are supposed to be globally coordinated.
BOOL
ShapedWindow::ptInPart( int ptx, int pty )
{
	if( GUIPart::ptInPart( ptx, pty ))
	{
		Uint8* bits;
		ptx -= getRectRef()->x;
		pty -= getRectRef()->y;
		bits = ((Uint8*)getSurface()->pixels) + pty*getSurface()->pitch
			+ ptx * getSurface()->format->BytesPerPixel;
		return *bits != 0;
	}
	else
		return false;
}
