#include "ShortCutListener.h"

ShortCutListener::ShortCutListener()
{
	windowa = windowb = windowc = NULL;
	// Sensitive to keys, and not to mouse
	setDefaultAcceptKey( true );
	setAcceptKey( true );
	setDefaultAcceptMouse( false );
	setAcceptMouse( false );
}

ShortCutListener::~ShortCutListener()
{
}

BOOL
ShortCutListener::handleKeyDown( SDL_Event* e )
{
	switch( e->key.keysym.sym )
	{
		case SDLK_SPACE:
			if( windowa )
				windowa->setVisible( ! windowa->isVisible());
			if( windowb )
				windowb->setVisible( ! windowb->isVisible());
			if( windowc )
				windowc->setVisible( ! windowc->isVisible());
			return true;
		case SDLK_1:
			if( windowa )
				windowa->setVisible( ! windowa->isVisible());
			return true;
		case SDLK_2:
			if( windowb )
				windowb->setVisible( ! windowb->isVisible());
			return true;
		case SDLK_3:
			if( windowc )
				windowc->setVisible( ! windowc->isVisible());
			return true;
		default:
			return false;
	}
}

void
ShortCutListener::setWindowA( AWindow* window )
{
	windowa = window;
}

void
ShortCutListener::setWindowB( AWindow* window )
{
	windowb = window;
}

void
ShortCutListener::setWindowC( AWindow* window )
{
	windowc = window;
}