/***************************************************************************
    copyright            : (C) 2000 by Masahiro Minami
    email                : elsur@aaa.letter.co.jp
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Toggle GUI focus. Think of LineEdit --- you can toggle fields by TAB key !

#include "CommanderGroup.h"
#include "../ACommander.h"

CommanderGroup::CommanderGroup()
{
	group = new AList<ACommander>;
	current = 0;
}

CommanderGroup::~CommanderGroup()
{
	if( group )
		delete group;
}

BOOL
CommanderGroup::addMember( ACommander* mem )
{
	if( group )
	{
		group->Add( mem );
		mem->setGroup( this );
	}
	return true;
}

BOOL
CommanderGroup::removeMember( ACommander* mem )
{
	Uint32 i;
	for( i = 0; i < group->Size(); i++)
		if( (*group)[i] == mem )
			break;
	
	if( i<group->Size())
	{
		(*group)[i]->setGroup( NULL );
		group->Remove(i);
		return true;
	}
	else
		return false;
}

void
CommanderGroup::next()
{
	if( (*group)[current] )
		(*group)[current]->setFocus( false );
	
	current++;
	if( current >= group->Size())
		current = 0;
	
	if( (*group)[current] )
		(*group)[current]->setFocus( true );
}

void
CommanderGroup::requestFocus( ACommander* mem )
{
	Uint32 i;
	for( i = 0; i < group->Size(); i++)
	{
		if((*group)[i] != mem )
			(*group)[i]->setFocus( false );
		else
			current = i;
	}
}