/***************************************************************************
    copyright            : (C) 2000 by Masahiro Minami
    email                : elsur@aaa.letter.co.jp
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// Use this class for animating GUI --- or to invoke any function periodically

#include "GUIAnimator.h"

GUIAnimator::GUIAnimator()
{
	clientList = new AList<AnimatorClient>;
	frameRate = 100;
	lastTick = 0;
}

GUIAnimator::~GUIAnimator()
{
	if( clientList )
		delete clientList;
}

BOOL
GUIAnimator::addClient( AnimatorClient* client )
{
	if( clientList )
		clientList->Add( client );
	return true;
}

BOOL
GUIAnimator::removeClient( AnimatorClient* client )
{
	if( clientList )
		for( Uint32 i = 0; i < clientList->Size(); i++ )
			if( (*clientList)[i] == client )
			{
				clientList->Remove(i);
				return true;
			}
	return false;
}

void
GUIAnimator::animate()
{
	if( clientList && SDL_GetTicks() >= lastTick + frameRate )
	{
		lastTick = SDL_GetTicks();
		for( Uint32 i = 0; i < clientList->Size(); i++ )
			if( (*clientList)[i] )
				(*clientList)[i]->animate();
	}
}

void
GUIAnimator::setFrameRate( Uint32 rate )
{
	frameRate = rate;
}

Uint32
GUIAnimator::getFrameRate()
{
	return frameRate;
}