#include "PlayerMove.h"
#include "../Log.h"

PlayerMove::PlayerMove(MessageManager *mesMan)
  {
  this->mesMan=mesMan;
  player=0;
  UpdateTime=0;

  // Sensitive to keys, and not to mouse
  setDefaultAcceptKey( true );
  setAcceptKey( true );
  setDefaultAcceptMouse( false );
  setAcceptMouse( false );
  }

PlayerMove::~PlayerMove()
  {
  }

void PlayerMove::Update(Object *player)
  {
  this->player=player;
  }


BOOL PlayerMove::handleKeyDown( SDL_Event* e )
  {
  assert(player!=NULL);

  if(SDL_GetTicks()-UpdateTime<ANIMATION_MSECONDS_PER_FRAME)
    {
    return false;
    }

  switch( e->key.keysym.sym )
    {
	case SDLK_UP:      
      {
      Uint32 x,y,z;
      player->Pos.GetXYZ(&x,&y,&z);
      y-=3;
      Log::Debug("Move player UP (%i,%i)",x,y);
      player->Pos.MoveTo(x,y,z);
      }
      break;
	case SDLK_DOWN:
      {
      Uint32 x,y,z;
      player->Pos.GetXYZ(&x,&y,&z);
      y+=3;
      Log::Debug("Move player DOWN (%i,%i)",x,y);
      player->Pos.MoveTo(x,y,z);
      }
      break;
	case SDLK_RIGHT:
      {
      Uint32 x,y,z;
      player->Pos.GetXYZ(&x,&y,&z);
      x+=3;
      Log::Debug("Move player RIGHT (%i,%i)",x,y);
      player->Pos.MoveTo(x,y,z);
      }
      break;
	case SDLK_LEFT:
      {
      Uint32 x,y,z;
      player->Pos.GetXYZ(&x,&y,&z);
      x-=3;
      Log::Debug("Move player LEFT (%i,%i)",x,y);
      player->Pos.MoveTo(x,y,z);
      }
      break;
	default:
	  return false;
	}

  UpdateTime=SDL_GetTicks();
  return true;
  }
