#ifndef ARIANNE_GenericMessage_H
#define ARIANNE_GenericMessage_H


#include "general.h"
#include "Socket.h"
#include <iostream>

/** 
This class stores a generic message type.
**/
class GenericMessage : public Disposable
  {
  public:
  Uint32 ID;
  Uint8 Type;
  Uint8 SubType;
  Uint8 Flags;
  Uint32 Length;
  AVector *Data;
  Uint32 TimeToken;

  GenericMessage();
  GenericMessage(GenericMessage const&);
  GenericMessage& operator=(GenericMessage const&);
  ~GenericMessage();

  void SetID(Uint32 ID);
  Uint32 GetID();
  Uint32 GetTimeToken();

  void GetType(Socket *socket);
  void GetSubType(Socket *socket);
  void GetFlags(Socket *socket);
  void GetLength(Socket *socket);
  void GetData(Socket *socket);

  void PutType(Socket *socket) const;
  void PutSubType(Socket *socket) const;
  void PutFlags(Socket *socket) const;
  void PutLength(Socket *socket) const;
  void PutData(Socket *socket) const;
  /** Dumps the GenericMessage to any kind of ostream, useful for debugging purposes */
  void Dump(std::ostream& out) const;
  };

BOOL shouldCompress(Uint32 size);

Socket& operator>>(Socket&, GenericMessage&);
Socket& operator<<(Socket&, GenericMessage const&);

#endif