/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This a common, void pointer based List class.

    OBSOLOTE, just use AList<void>

***************************************************************************/
#include "List.h"
#include "templock.h"
    
LIST::LIST(LIST const &List)
  {
  }

/**
This is the constructor of the class.
**/
LIST::LIST()
{
    list=new CELL;
    list->object=NULL;
    list->next=NULL;
    NumCells=0;
}

/**
The class destructor.
**/
LIST::~LIST()
{
    TempLock lock(m_mutex);

    Clear();
    delete list;
}

/**
This clears the list.
**/
void LIST::Clear()
{
    TempLock lock(m_mutex);

    CELL *p=list->next;
    while (p) {
	CELL *pn=p->next;
	//delete p->object;
	delete p;
	p=pn;
    }
    list->next=NULL;
    NumCells=0;
}

/**
This returns TRUE if the list is empty, FALSE otherwise.
**/
BOOL LIST::isEmpty()
{
    return (NumCells==0);
}

/**
This inserts an object to the list at position Pos.
**/
void LIST::Add(Disposable *object,int Pos)
{
    TempLock lock(m_mutex);

    CELL *q=list;
    CELL *p=new CELL;
    NumCells++;

    for(int i=0;i<Pos;i++) 
      {
	  if(q->next!=NULL) 
        {
	    q=q->next;
	    }
      }

    p->object=object;
    p->next=q->next;
    q->next=p;
}

/**
Removes and deletes an object from the list.
**/
void LIST::Free(int Pos)
{
    TempLock lock(m_mutex);

    Disposable *object=Remove(Pos);
    if (object) delete object;
}

/**
This removes an object from the position pos of the list.
It returns the removed object.
**/
Disposable *LIST::Remove(int Pos)
{
    TempLock lock(m_mutex);

    CELL *q=list,*p;
    Disposable *object=NULL;
           
    for(int i=0;i<Pos;i++) 
      {
	  if(q->next!=NULL)
        { 
        q=q->next;
        }
      }

    if(q->next!=NULL)
      {
	  p=q->next;
	  q->next=p->next;
	  object=p->object;
	  delete p;
	  NumCells--;
      }

    return object;
}

/**
This returns the number of elements that the list contains.
**/
int LIST::Size()
{
  return NumCells;
}

/**
This returns a pointer to the object that is at position i.
**/
Disposable *LIST::operator[](int i)
{
    TempLock lock(m_mutex);

    CELL *q=list;

    for(int j=0;j<i;j++) {
        if(q->next!=NULL) q=q->next;
    }

    if(q->next) return q->next->object;

    return NULL;
}

