#ifndef __ARIANNE_RPG_List_hpp
#define __ARIANNE_RPG_List_hpp

#include "general.h"
#include "mutex.h"

struct CELL
{
    Disposable *object;
    CELL *next;
};

/**
This class holds a list of Disposable objects.

FIXME:
  Make it Thread-Safe.  
**/
class LIST
{
    CELL *list;
    int NumCells;
	Mutex m_mutex;
    LIST(LIST const&);
    LIST& operator=(LIST const&);
public:
    LIST();
    ~LIST();
    void Clear();
    LIST* clone(){return new LIST(*this);}
    BOOL isEmpty();
    void Add(Disposable *object,int pos);
    void Free(int pos);
    Disposable *Remove(int pos);
    int Size();
    // we can't return a reference here as it may be NULL
    Disposable *operator[](int i);

};

/* This Get the size of the whole list. */
#define GetSize_LIST(MACRO_LIST,MACRO_TYPE,MACRO_RESULT) {MACRO_RESULT=2;for(int i=0;i<MACRO_LIST->Size();i++) MACRO_RESULT+=((MACRO_TYPE *)(*MACRO_LIST)[i])->GetSize();}
#define ToVector_LIST(MACRO_LIST,MACRO_TYPE,MACRO_RESULT) {AVector *vector=new AVector;AUint16 lenght;lenght=(Uint16)MACRO_LIST->Size();lenght.ToVector(vector);for(int i=0;i<MACRO_LIST->Size();i++) ((MACRO_TYPE *)(*MACRO_LIST)[i])->ToVector(vector); (*MACRO_RESULT)+vector;delete vector;}
#define FromVector_LIST(MACRO_LIST,MACRO_TYPE,MACRO_RESULT) {AUint16 lenght;lenght.FromVector(MACRO_RESULT);if(MACRO_LIST) delete MACRO_LIST;MACRO_LIST=new LIST;for(int i=0;i<(Uint16)lenght;i++) {MACRO_TYPE *MACRO_OBJECT=new MACRO_TYPE;MACRO_OBJECT->FromVector(MACRO_RESULT);MACRO_LIST->Add(MACRO_OBJECT,0);}}                                                     


#endif // __ARIANNE_RPG_List_hpp
