#ifndef ARIANNE_MAPOBJECT_H 
#define ARIANNE_MAPOBJECT_H

#include "general.h"
#include "Tda.h"
#include "AList.h"
#include "Object.h"

#include "ObjectPiece.h"

class MapObjects
  {
  AList<ObjectPiece> *MapPiece;
  
  public:
  MapObjects();
  ~MapObjects();

  void CreateNewObjectPiece(Uint32 x_init,Uint32 y_init,Uint32 x_end,Uint32 y_end);

  BOOL SavePiece(AString FileName,Uint32 x_init,Uint32 y_init,Uint32 x_end,Uint32 y_end);
  BOOL LoadPiece(AString FileName,Uint32 x_init,Uint32 y_init,Uint32 x_end,Uint32 y_end);

  /** Empty the Terrain list */
  void Clear();

  AList<Object> *GetListObjects(Uint32 x_init=0,Uint32 y_init=0,Uint32 x_end=RANGE_INFINITY,Uint32 y_end=RANGE_INFINITY);

  Object *GetObject(Uint32 uID);
  Object *GetObject(Object *object);
  void AddObject(Object *object);
  void RemoveObject(Object *object);
  void RemoveObject(Uint32 uID);

  /** Add a terrain piece to the list or update it if the terrain piece exist */
  void UpdateObject(Object *object);

  /** Returns objects in the given box. */
  AList<Object> *isInRange(Position& Center, Uint32 Range);

  Uint32 GetNumObjects();
  void GetSize(Uint32 *x1,Uint32 *y1,Uint32 *x2,Uint32 *y2);
  };

#endif