#ifndef ARIANNE_MAPTerrain_H 
#define ARIANNE_MAPTerrain_H

#include "general.h"
#include "Tda.h"
#include "AList.h"
#include "Terrain.h"

#include "TerrainPiece.h"

class MapTerrains
  {
  AList<TerrainPiece> *MapPiece;
  
  public:
  MapTerrains();
  ~MapTerrains();

  void CreateNewTerrainPiece(Uint32 x_init,Uint32 y_init,Uint32 x_end,Uint32 y_end);

  BOOL SavePiece(AString FileName,Uint32 x_init,Uint32 y_init,Uint32 x_end,Uint32 y_end);
  BOOL LoadPiece(AString FileName,Uint32 x_init,Uint32 y_init,Uint32 x_end,Uint32 y_end);

  /** Empty the Terrain list */
  void Clear();

  AList<Terrain> *GetListTerrains(Uint32 x_init=0,Uint32 y_init=0,Uint32 x_end=RANGE_INFINITY,Uint32 y_end=RANGE_INFINITY);

  Terrain *GetTerrain(Uint32 x1,Uint32 y1,Uint32 z1);
  void AddTerrain(Terrain *terrain);
  void RemoveTerrain(Terrain *terrain);
  void RemoveTerrain(Uint32 x1,Uint32 y1,Uint32 z1);

  /** Add a terrain piece to the list or update it if the terrain piece exist */
  void UpdateTerrain(Terrain *terrain);

  /** Returns Terrains in the given box. */
  AList<Terrain> *isInRange(Uint32 x1,Uint32 y1,Uint32 x2,Uint32 y2);

  Uint32 GetNumTerrains();

  void GetSize(Uint32 *x1,Uint32 *y1,Uint32 *x2,Uint32 *y2);
  };

#endif