#include "C2S_ACTION.h"

char Message_C2S_ACTION::sType=ARIANNE_GAME;

char Message_C2S_ACTION::sSubtype=ARIANNE_ACTION;

char Message_C2S_ACTION::sPriority=ARIANNE_realtime;

Message_C2S_ACTION::Message_C2S_ACTION(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  action=0;
  }

Message_C2S_ACTION::~Message_C2S_ACTION()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_C2S_ACTION::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_C2S_ACTION::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_C2S_ACTION::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_C2S_ACTION::GetSize()
  {
  /* TODO: Implement here the GetSize Method */
  return action->GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_C2S_ACTION::ToVector(AVector *vector)
  {
  /* TODO: Implement here the ToVector Method */
  action->ToVector(vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_C2S_ACTION::FromVector(AVector *Vector)
  {
  if(action)
    {
    delete action;
    }

  action=new Action;
  action->FromVector(Vector);
  }
  
void Message_C2S_ACTION::Setaction(Action *action)
  {
  this->action=action;
  }
  
Action* Message_C2S_ACTION::Getaction()
  {
  return action;
  }
  
