#include "C2S_ASK_MAP_PIECE.h"

char Message_C2S_ASK_MAP_PIECE::sType=ARIANNE_MAP_RULES;

char Message_C2S_ASK_MAP_PIECE::sSubtype=ARIANNE_MAP_PIECE;

char Message_C2S_ASK_MAP_PIECE::sPriority=ARIANNE_realtime;

Message_C2S_ASK_MAP_PIECE::Message_C2S_ASK_MAP_PIECE(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  }

Message_C2S_ASK_MAP_PIECE::~Message_C2S_ASK_MAP_PIECE()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_C2S_ASK_MAP_PIECE::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_C2S_ASK_MAP_PIECE::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_C2S_ASK_MAP_PIECE::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_C2S_ASK_MAP_PIECE::GetSize()
  {
  /* TODO: Implement here the GetSize Method */
  return CRC.GetSize()+yend.GetSize()+xend.GetSize()+yinit.GetSize()+xinit.GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_C2S_ASK_MAP_PIECE::ToVector(AVector *Vector)
  {
  /* TODO: Implement here the ToVector Method */
  CRC.ToVector(Vector);
  yend.ToVector(Vector);
  xend.ToVector(Vector);
  yinit.ToVector(Vector);
  xinit.ToVector(Vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_C2S_ASK_MAP_PIECE::FromVector(AVector *Vector)
  {
  CRC.FromVector(Vector);
  yend.FromVector(Vector);
  xend.FromVector(Vector);
  yinit.FromVector(Vector);
  xinit.FromVector(Vector);
  }
  
void Message_C2S_ASK_MAP_PIECE::Setyend(AUint32 yend)
  {
  this->yend=yend;
  }
  
AUint32 Message_C2S_ASK_MAP_PIECE::Getyend()
  {
  return yend;
  }
  
void Message_C2S_ASK_MAP_PIECE::Setxend(AUint32 xend)
  {
  this->xend=xend;
  }
  
AUint32 Message_C2S_ASK_MAP_PIECE::Getxend()
  {
  return xend;
  }
  
void Message_C2S_ASK_MAP_PIECE::Setyinit(AUint32 yinit)
  {
  this->yinit=yinit;
  }
  
AUint32 Message_C2S_ASK_MAP_PIECE::Getyinit()
  {
  return yinit;
  }
  
void Message_C2S_ASK_MAP_PIECE::Setxinit(AUint32 xinit)
  {
  this->xinit=xinit;
  }
  
AUint32 Message_C2S_ASK_MAP_PIECE::Getxinit()
  {
  return xinit;
  }
 
void Message_C2S_ASK_MAP_PIECE::SetCRC(AUint32 CRC)
  {
  this->CRC=CRC;
  }
  
AUint32 Message_C2S_ASK_MAP_PIECE::GetCRC()
  {
  return CRC;
  }
  
