#include "C2S_INFO_ABOUT_GAME.h"

char Message_C2S_INFO_ABOUT_GAME::sType=ARIANNE_CRASH_INFO;

char Message_C2S_INFO_ABOUT_GAME::sSubtype=ARIANNE_INFO_ABOUT_GAME;

char Message_C2S_INFO_ABOUT_GAME::sPriority=ARIANNE_realtime;

Message_C2S_INFO_ABOUT_GAME::Message_C2S_INFO_ABOUT_GAME(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  VitalData=0;
  }

Message_C2S_INFO_ABOUT_GAME::~Message_C2S_INFO_ABOUT_GAME()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_C2S_INFO_ABOUT_GAME::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_C2S_INFO_ABOUT_GAME::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_C2S_INFO_ABOUT_GAME::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_C2S_INFO_ABOUT_GAME::GetSize()
  {
  /* TODO: Implement here the GetSize Method */
  return VitalData->GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_C2S_INFO_ABOUT_GAME::ToVector(AVector *Vector)
  {
  /* TODO: Implement here the ToVector Method */
  if(VitalData)
    {
    delete VitalData;
    }

  VitalData=new AVector;

  VitalData->ToVector(Vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_C2S_INFO_ABOUT_GAME::FromVector(AVector *Vector)
  {
  if(VitalData)
    {
    delete VitalData;
    }

  VitalData=new AVector();

  VitalData->FromVector(Vector);
  }
  
void Message_C2S_INFO_ABOUT_GAME::SetVitalData(AVector* VitalData)
  {
  this->VitalData=VitalData;
  }
  
AVector* Message_C2S_INFO_ABOUT_GAME::GetVitalData()
  {
  return VitalData;
  }
  
