#include "C2S_LOAD_CHARACTER.h"

char Message_C2S_LOAD_CHARACTER::sType=ARIANNE_CHARACTER_MANAGEMENT;

char Message_C2S_LOAD_CHARACTER::sSubtype=ARIANNE_LOAD_CHARACTER;

char Message_C2S_LOAD_CHARACTER::sPriority=ARIANNE_realtime;

Message_C2S_LOAD_CHARACTER::Message_C2S_LOAD_CHARACTER(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  }

Message_C2S_LOAD_CHARACTER::~Message_C2S_LOAD_CHARACTER()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_C2S_LOAD_CHARACTER::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_C2S_LOAD_CHARACTER::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_C2S_LOAD_CHARACTER::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_C2S_LOAD_CHARACTER::GetSize()
  {
  /* TODO: Implement here the GetSize Method */
  return Password.GetSize()+Name.GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_C2S_LOAD_CHARACTER::ToVector(AVector *Vector)
  {
  /* TODO: Implement here the ToVector Method */
  Password.ToVector(Vector);
  Name.ToVector(Vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_C2S_LOAD_CHARACTER::FromVector(AVector *Vector)
  {
  Password.FromVector(Vector);
  Name.FromVector(Vector);
  }
  
void Message_C2S_LOAD_CHARACTER::SetPassword(AString Password)
  {
  this->Password=Password;
  }
  
AString Message_C2S_LOAD_CHARACTER::GetPassword()
  {
  return Password;
  }
  
void Message_C2S_LOAD_CHARACTER::SetName(AString Name)
  {
  this->Name=Name;
  }
  
AString Message_C2S_LOAD_CHARACTER::GetName()
  {
  return Name;
  }
  
