#include "C2S_SYSTEM_INFO.h"

char Message_C2S_SYSTEM_INFO::sType=ARIANNE_ADMIN;

char Message_C2S_SYSTEM_INFO::sSubtype=ARIANNE_SYSTEM_INFO;

char Message_C2S_SYSTEM_INFO::sPriority=ARIANNE_realtime;

Message_C2S_SYSTEM_INFO::Message_C2S_SYSTEM_INFO(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  }

Message_C2S_SYSTEM_INFO::~Message_C2S_SYSTEM_INFO()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_C2S_SYSTEM_INFO::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_C2S_SYSTEM_INFO::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_C2S_SYSTEM_INFO::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_C2S_SYSTEM_INFO::GetSize()
  {
  /* TODO: Implement here the GetSize Method */
  return SoundCard.GetSize()+VideoCard.GetSize()+Memory.GetSize()+Cpu.GetSize()+Os.GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_C2S_SYSTEM_INFO::ToVector(AVector *Vector)
  {
  /* TODO: Implement here the ToVector Method */
  SoundCard.ToVector(Vector);
  VideoCard.ToVector(Vector);
  Memory.ToVector(Vector);
  Cpu.ToVector(Vector);
  Os.ToVector(Vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_C2S_SYSTEM_INFO::FromVector(AVector *Vector)
  {
  SoundCard.FromVector(Vector);
  VideoCard.FromVector(Vector);
  Memory.FromVector(Vector);
  Cpu.FromVector(Vector);
  Os.FromVector(Vector);
  }
  
void Message_C2S_SYSTEM_INFO::SetSoundCard(AString SoundCard)
  {
  this->SoundCard=SoundCard;
  }
  
AString Message_C2S_SYSTEM_INFO::GetSoundCard()
  {
  return SoundCard;
  }
  
void Message_C2S_SYSTEM_INFO::SetVideoCard(AString VideoCard)
  {
  this->VideoCard=VideoCard;
  }
  
AString Message_C2S_SYSTEM_INFO::GetVideoCard()
  {
  return VideoCard;
  }
  
void Message_C2S_SYSTEM_INFO::SetMemory(AString Memory)
  {
  this->Memory=Memory;
  }
  
AString Message_C2S_SYSTEM_INFO::GetMemory()
  {
  return Memory;
  }
  
void Message_C2S_SYSTEM_INFO::SetCpu(AString Cpu)
  {
  this->Cpu=Cpu;
  }
  
AString Message_C2S_SYSTEM_INFO::GetCpu()
  {
  return Cpu;
  }
  
void Message_C2S_SYSTEM_INFO::SetOs(AString Os)
  {
  this->Os=Os;
  }
  
AString Message_C2S_SYSTEM_INFO::GetOs()
  {
  return Os;
  }
  
