#include "S2C_LOGIN.h"

char Message_S2C_LOGIN::sType=ARIANNE_ADMIN;

char Message_S2C_LOGIN::sSubtype=ARIANNE_LOGIN;

char Message_S2C_LOGIN::sPriority=ARIANNE_realtime;

Message_S2C_LOGIN::Message_S2C_LOGIN(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  }

Message_S2C_LOGIN::~Message_S2C_LOGIN()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_S2C_LOGIN::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_S2C_LOGIN::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_S2C_LOGIN::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_S2C_LOGIN::GetSize()
  {
  /* TODO: Implement here the GetSize Method */
  return ServerToLog.GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_S2C_LOGIN::ToVector(AVector *Vector)
  {
  /* TODO: Implement here the ToVector Method */
  ServerToLog.ToVector(Vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_S2C_LOGIN::FromVector(AVector *Vector)
  {
  ServerToLog.FromVector(Vector);
  }
  
void Message_S2C_LOGIN::SetServerToLog(AString ServerToLog)
  {
  this->ServerToLog=ServerToLog;
  }
  
AString Message_S2C_LOGIN::GetServerToLog()
  {
  return ServerToLog;
  }
  
