#include "S2C_MAP_PIECE.h"
#include "../Terrain.h"

char Message_S2C_MAP_PIECE::sType=ARIANNE_MAP_RULES;

char Message_S2C_MAP_PIECE::sSubtype=ARIANNE_MAP_PIECE;

char Message_S2C_MAP_PIECE::sPriority=ARIANNE_realtime;

Message_S2C_MAP_PIECE::Message_S2C_MAP_PIECE(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  terrains=0;
  }

Message_S2C_MAP_PIECE::~Message_S2C_MAP_PIECE()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_S2C_MAP_PIECE::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_S2C_MAP_PIECE::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_S2C_MAP_PIECE::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_S2C_MAP_PIECE::GetSize()
  {
  return terrains->GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_S2C_MAP_PIECE::ToVector(AVector *Vector)
  {
  terrains->ToVector(Vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_S2C_MAP_PIECE::FromVector(AVector *Vector)
  {
  if(terrains)
    {
    terrains->Clear();
    delete terrains;
    }

  terrains=new AList<Terrain>;
  terrains->FromVector(Vector);
  }
  
void Message_S2C_MAP_PIECE::Setterrains(AList<Terrain>* terrains)
  {
  this->terrains=terrains;
  }
  
AList<Terrain>* Message_S2C_MAP_PIECE::Getterrains()
  {
  return terrains;
  }
  
