#include "S2C_PERCEPTION.h"
#include "../Object.h"

char Message_S2C_PERCEPTION::sType=ARIANNE_GAME;

char Message_S2C_PERCEPTION::sSubtype=ARIANNE_PERCEPTION;

char Message_S2C_PERCEPTION::sPriority=ARIANNE_realtime;

Message_S2C_PERCEPTION::Message_S2C_PERCEPTION(MessageManager *MesMan)
  {
  this->mMesMan=MesMan;
  Objects=0;
  }

Message_S2C_PERCEPTION::~Message_S2C_PERCEPTION()
  {
  }

/**
This method test if there is a message of this type-subtype in the 
MessageManager waiting to be processed.
**/
BOOL Message_S2C_PERCEPTION::isEmpty(Uint32 ID)
  {
  return mMesMan->IsEmpty(sType,sSubtype,ID);
  }
  
/**
This method add a message to the MessageManager in order to be send.
**/
void Message_S2C_PERCEPTION::Put(Uint32 ID)
  {
  /* We simply create a new generic Message and fill it using the next kind of
     data . */

  GenericMessage *GenMes=new GenericMessage();
  GenMes->ID=ID;
  GenMes->Type=this->GetType();
  GenMes->SubType=this->GetSubtype();
  GenMes->Length=this->GetSize();
  this->ToVector(GenMes->Data);

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    tmp->AddOutMessage(GenMes);
    return;
    }

  /* We have a message that hasn't any of the known types. */
  }
  
/**
This method gets a message from the MessageManager and fill the variables
of this object with it.
**/
BOOL Message_S2C_PERCEPTION::Get(Uint32 ID)
  {
  GenericMessage *GenMes;

  /* Now we add this to the OutMessage queue */
  Queue *tmp=mMesMan->GetQueue(sType);
  if(tmp!=NULL)
    {
    GenMes=tmp->GetInMessage(GetSubtype(),ID);
    if(GenMes!=NULL)
      {
      this->ID=GenMes->ID;
      this->FromVector(GenMes->Data);
      delete GenMes;
      return TRUE;
      }
    else
      {
      return FALSE;
      }
    }
  /* We have a message that hasn't any of the known types. */
  return FALSE;
  
  }
  
  
/**
This method returns the size of the Message data
**/
Uint16 Message_S2C_PERCEPTION::GetSize()
  {
  return Objects->GetSize()+perception.GetSize()+isCleverUpdated.GetSize()+uID.GetSize();
  }
  
/**
This method return an array of chars
**/
void Message_S2C_PERCEPTION::ToVector(AVector *Vector)
  {
  Objects->ToVector(Vector);
  perception.ToVector(Vector);
  isCleverUpdated.ToVector(Vector);
  uID.ToVector(Vector);
  }
  
/**
This method fill the object with data from an array of chars
**/
void Message_S2C_PERCEPTION::FromVector(AVector *Vector)
  {
  if(Objects) 
    {
    Objects->Clear();
    delete Objects;
    }

  Objects=new AList<Object>;

  Objects->FromVector(Vector);

  perception.FromVector(Vector);
  isCleverUpdated.FromVector(Vector);
  uID.FromVector(Vector);
  }
  
void Message_S2C_PERCEPTION::SetObjects(AList<Object>* Objects)
  {
  this->Objects=Objects;
  }
  
AList<Object>* Message_S2C_PERCEPTION::GetObjects()
  {
  return Objects;
  }
  
void Message_S2C_PERCEPTION::Setperception(Perception perception)
  {
  this->perception=perception;
  }
  
Perception Message_S2C_PERCEPTION::Getperception()
  {
  return perception;
  }
  
void Message_S2C_PERCEPTION::SetisCleverUpdated(ABool isCleverUpdated)
  {
  this->isCleverUpdated=isCleverUpdated;
  }
  
ABool Message_S2C_PERCEPTION::GetisCleverUpdated()
  {
  return isCleverUpdated;
  }
  
void Message_S2C_PERCEPTION::SetuID(AUint32 uID)
  {
  this->uID=uID;
  }
  
AUint32 Message_S2C_PERCEPTION::GetuID()
  {
  return uID;
  }
  
