#ifndef ARIANNE_NetworkInit_H
#define ARIANNE_NetworkInit_H

#include "general.h"
#include "MessageManager.h"
#include "NetworkManager.h"

/**
This class init all the Network Layer, creating the queues, connecting things,
getting up sockets, and all these stuff.
**/
class NetworkInit
  {
  MessageManager *mMesMan;
  NetworkManager *mNetMan;
  Uint32 chrono_start,chrono_end;

  public:  
  NetworkInit();
  ~NetworkInit();
  /** Returns the MessageManager */
  MessageManager *GetMessageManager();

  /** Returns the NetworkManager */
  NetworkManager *GetNetworkManager();

  /** Create the Network Layer of Arianne. */
  void Connect(char const* server=NULL,Uint16 port=0);

  /* Launch the network layer */
  void Run();

  /* Stop the network layer. */
  void Shutdown();
  };

#endif