#ifndef ARIANNE_NetworkManager_H
#define ARIANNE_NetworkManager_H

#include "general.h"
#include "List.h"
#include "Socket.h"
#include "SocketSet.h"
#include "Queue.h"
#include "thread.h"

/**
Network manager class is responsible of taking data from the queue and send it to the Net.
It also get the data from the Net and put it on the correct Queue.
**/
class NetworkManager
#ifndef macintosh
	: public LoopThread
#endif
  {
  /** Actual BandWidth Limit **/
  int mBandWidthLimit;
  /** List of queues to manage **/
  Queue **mlQueues;
  /** Socket where the communication takes place. **/
  Socket* mSocket;
  SocketSet* mSocketSet;

  /** Tell if the Network manager is running **/
  BOOL mRunning;

  public:
  NetworkManager();
  ~NetworkManager();

  void SetBandWidthLimit(int BytePerSec);
  int GetBandWidthLimit();
  
  int SizeQueues();
  Queue *GetQueue(int Position);
  void AddQueue(Queue *queue);

  void SetSocket(Socket *Socket);
  void SetSocket(Socket *socket,SocketSet *socketset);
  Socket *GetSocket();

  virtual void loop();
  void Flush();
  BOOL IsRunning();

  #ifdef macintosh
  ThreadID	senderID, receiverID;

  void startThread();
  void stopThread();
  #endif
  };

#endif