#ifndef ARIANNE_NetworkServerManager_H
#define ARIANNE_NetworkServerManager_H

#include "general.h"
#include "List.h"
#include "Socket.h"
#include "SocketSet.h"
#include "Queue.h"
#include "thread.h"
#include "PlayerID.h"

/**
Network manager class is responsible of taking data from the queue and send it to the Net.
It also get the data from the Net and put it on the correct Queue.
**/
class NetworkServerManager
#ifndef macintosh
		: public LoopThread
#endif
  {
  /** Actual BandWidth Limit **/
  int mBandWidthLimit;
  /** List of queues to manage **/
  Queue **mlQueues;
  /** Socket where the communication takes place. **/
  Socket *mSocket;
  SocketSet *mSocketSet;

  Socket *mlSockets[MAX_CONNECTIONS_PER_SERVER];
  Uint8 isLogout[MAX_CONNECTIONS_PER_SERVER];
  Uint16 LastIndexUsed;

  Uint32 Errors;

  /** Tell if the Network manager is running **/
  BOOL mRunning;
#ifndef macintosh
  void TestForNewConnections();
  void SendDataToClient(Uint32 ID);
  void RecvDataFromClient(Uint32 ID);
#endif
  public:
  NetworkServerManager();
  ~NetworkServerManager();

  void SetBandWidthLimit(int BytePerSec);
  int GetBandWidthLimit();
  
  int SizeQueues();
  Queue *GetQueue(int Position);
  void AddQueue(Queue *queue);

  void SetSocket(Socket *Socket);
  void SetSocket(Socket *socket,SocketSet *socketset);
  
  Socket *GetSocket();
  Socket *GetSocket(Uint16 i);
  /* Looks scary when it is a Uint32, don't you think so? :-)*/
  Uint32 GetErrors();

  void CloseConnection(Uint16 i);
#ifndef macintosh
  void loop();
#endif
  BOOL IsRunning();
  
  #ifdef macintosh
  void startListening();
  int getNewID();
  void lockID( int id );
  void freeID( int id );
  
  BOOL addNewSocket( Socket* sock );
  private:
  	int clients[MAX_CONNECTIONS_PER_SERVER];
  #endif
  };

#ifdef macintosh
pascal void* listenThreadProc( void* netManagerPtr );
#endif

#endif