/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This the abstraction of whatever object you are going to find on
    Arianne.
***************************************************************************/
#include "Object.h"

/**
This is the class constructor.
**/
Object::Object()
  {
  mID=0;
  mType=0;
  mData=new AVector;
  }


/**
This is the class destructor.
**/
Object::~Object()
  {
  // delete data and invalidate pointers
  if(mData)
    { 
    delete mData; 
    mData=0;
    }
  }

/**
This set the object type.
**/
void Object::SetType(Uint16 type)
  {
  mType=type;
  }

/**
This returns the object type.
**/
Uint16 Object::GetType()
  {
  return (Uint16)mType;
  }

Uint16 Object::GetSize()
  {
  assert(mData!=NULL);
   
  return mID.GetSize()+mType.GetSize()+mData->GetSize()+4+Pos.GetSize()+Resume.GetSize();
  }

void Object::ToVector(AVector *vector)
  {
  assert(vector!=NULL);
   
  mID.ToVector(vector);
  mType.ToVector(vector);
  Pos.ToVector(vector);
  Resume.ToVector(vector);

  mData->ToVector(vector);
  }

void Object::FromVector(AVector *vector)
  {
  assert(vector!=NULL);
   
  mID.FromVector(vector);
  mType.FromVector(vector);
  Pos.FromVector(vector);
  Resume.FromVector(vector);

  if(mData)
    {
    delete mData;    
    }
  mData=new AVector();

  mData->FromVector(vector);
  }

void Object::SetPos(Position& Pos)
  {
  this->Pos=Pos;
  }

Position& Object::GetPos()
  {
  return Pos;
  }

void Object::SetGFXResume(GFXResume& Resume)
  {
  this->Resume=Resume;
  }

GFXResume& Object::GetGFXResume()
  {
  return Resume;
  }

Object *Object::Clone()
  {
  Object *tmp=new Object;

  tmp->mID=mID;
  tmp->mType=mType;
  tmp->Pos=Pos;
  tmp->Resume=Resume;

  tmp->mData->SetVectorSize(mData->GetVectorSize());
  tmp->mData->AddUint8(mData->Get(),mData->GetVectorSize());

  return tmp;
  }
