#ifndef ARIANNE_Object_H
#define ARIANNE_Object_H

#include "general.h"
#include "GFXResume.h"
#include "Position.h"
#include "List.h"

/**
This stores a object.
An object is the basic entity of Arianne.

All the objects have a position.
The rest of attributes has a specific meaning that is determined by 
the objects type.

**/
class Object: public Disposable
  {
  public:
  AUint32 mID;
  AUint16 mType;
  AVector *mData;
  Position Pos;
  GFXResume Resume;


  public:
  Object();
  ~Object();

  void SetPos(Position& Pos);
  Position& GetPos();
  void SetGFXResume(GFXResume& Resume);
  GFXResume& GetGFXResume();  
  void SetType(Uint16 type);
  Uint16 GetType();
  Uint16 GetSize();
  void ToVector(AVector *vector);
  void FromVector(AVector *vector);
  Object *Clone();
  };

#endif
