#ifndef ARIANNE_ObjectPiece_H 
#define ARIANNE_ObjectPiece_H

#include "general.h"
#include "Tda.h"
#include "AList.h"
#include "Object.h"

class ObjectPiece
  {
  public:
  Uint32 x_init,y_init,x_end,y_end;
  AList<Object> *Objects;

  ObjectPiece();
  ~ObjectPiece();

  Uint32 GetSize();
  void ToVector(AVector *Vector);
  void FromVector(AVector *Vector);

  void Clear();

  BOOL isInside(Uint32 x,Uint32 y);
  BOOL isInside(Object *piece);

  Object *GetObject(Uint32 uID);
  void AddObject(Object *object);
  BOOL UpdateObject(Object *object);
  BOOL RemoveObject(Object *object);
  BOOL RemoveObject(Uint32 uID);

  void isInRange(AList<Object> *list,Position& Center, Uint32 Range);

  BOOL isNeighbor(ObjectPiece *tmp);
  Uint32 GetNumObjects();
  };

#endif