/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This class is translate between Socket number on the server and player
    UID, that is unique.
***************************************************************************/
#include "PlayerID.h"

Player2ID::Player2ID()
  {
  mLastTime=new Uint32[MAX_CONNECTIONS_PER_SERVER];

  mlID=new Sint32[MAX_CONNECTIONS_PER_SERVER];
  for(int i=0;i<MAX_CONNECTIONS_PER_SERVER;i++)
    {
    mlID[i]=-1;
    }
  }

Player2ID::~Player2ID()
  {
  delete[] mlID;
  delete[] mLastTime;
  }

Uint32 Player2ID::GetLastTime(Uint32 ID)
  {
  return mLastTime[ID];
  }

void Player2ID::UpdateTime(Uint32 ID)
  {
  mLastTime[ID]=SDL_GetTicks();
  }

/**
Return the connection ID giving the Player ID.

If there are two identical numbers of Player then there is a problem
**/
Sint32 Player2ID::ID(Uint32 Player)
  {
  for(int i=0;i<MAX_CONNECTIONS_PER_SERVER;i++)
    {
    if(mlID[i]!=-1)
      {
      if((Uint32)mlID[i]==Player)
        {
        return i;
        }
      }
    }
  return -1; 
  }


/**
Return the Player ID giving the connection ID
**/
Sint32 Player2ID::Player(Uint32 ID)
  {
  if(ID<MAX_CONNECTIONS_PER_SERVER)
    {
    if(mlID[ID]!=-1)
      {
      return mlID[ID];
      }
    }
  return -1; 
  }

BOOL Player2ID::Add(Uint32 ID,Uint32 Player)
  {
  mLastTime[ID]=SDL_GetTicks();
  mlID[ID]=Player;
  return TRUE;
  }

BOOL Player2ID::Del(Uint32 ID)
  {
  mlID[ID]=-1;
  return TRUE;
  }

