#ifndef ARIANNE_Position_H
#define ARIANNE_Position_H

#include "general.h"

/**
This store the position and the orientation of an object.
One increment means 10 cm in "real" world
**/
class Position
  {
  AUint32 x,y,z;
  AUint32 lastX,lastY,lastZ;
  /* NOTE: It is normalize between 0-255 instead of 0-360 */
  AUint8 yaw,roll,pitch;

  /* NOTE: Although Speeds should be real, I don't know if it is portable. */
  AUint8 speedX,speedY,speedZ;  
  AUint8 speedYaw,speedRoll,speedPitch;  

  public:
  Position();
  ~Position();
  void SetXYZ(Uint32 x,Uint32 y,Uint32 z);
  void SetYRP(Uint8 yaw,Uint8 roll,Uint8 pitch);
  void GetXYZ(Uint32 *x,Uint32 *y,Uint32 *z);
  void GetXYZLast(Uint32 *x,Uint32 *y,Uint32 *z);
  void GetYRP(Uint8 *yaw,Uint8 *roll,Uint8 *pitch);
  void SetMovementSpeed(Uint8 x,Uint8 y,Uint8 z);
  void SetRotationSpeed(Uint8 yaw,Uint8 roll,Uint8 pitch);

  void MoveTo(Uint32 x,Uint32 y,Uint32 z);
  void Move(Uint8 Direction,Uint32 lastTime,Uint32 ActualTime);
  void Rotate(Uint8 Direction,Uint32 lastTime,Uint32 ActualTime);

  Uint16 GetSize();
  void ToVector(AVector *Vector);
  void FromVector(AVector *Vector);

  Uint32 Distance(Position& pos);
  };

#endif