#ifndef ARIANNE_Queue_H
#define ARIANNE_Queue_H

#include "general.h"
#include "AList.h"
#include "GenericMessage.h"

/**
This class manage a specified class of messages.
Message priority order is done here.
**/
class Queue : public Disposable
  {
  /** This is the list of In messages. **/
  AList<GenericMessage> mInMessage;

  /** This is the list of outgoing messages. **/
  AList<GenericMessage> mOutMessage;

  /** This identifies what type of queue it is **/
  /*(8 bits would be enough...)*/
  Uint8 mType;

  public:
  Queue();
  ~Queue();
  
  void ClearIn();
  void ClearOut();

  void AddInMessage(GenericMessage *GenMes);
  GenericMessage *GetInMessage(Uint32 ID=0);
  GenericMessage *GetInMessage(Uint8 subtype,Uint32 ID);
  Uint32 isInAvaliable(Uint8 subtype,Uint32 ID=0);
 
  void AddOutMessage(GenericMessage *GenMes);
  GenericMessage *GetOutMessage(Uint32 ID=0);
  GenericMessage *GetOutMessage(Uint8 subtype,Uint32 ID);
  Uint32 isOutAvaliable(Uint8 subtype,Uint32 ID=0);

  void SetType(int Type);
  int GetType();
  };

#endif