#ifndef ARIANNE_Screen_H 
#define ARIANNE_Screen_H

#include "general.h"

class Screen
  {
  static SDL_Surface *screen;
  static SDL_Surface *game_screen;

  public:
  /** Return the SDL_Surface used as screen */
  static SDL_Surface *GetScreen();

  /** Return the SDL_Surface used as game screen */
  static SDL_Surface *GetGameScreen();

  /** Set a SDL_Surface to be the screen */
  static void SetScreen(SDL_Surface *vscreen);

  /** Set the size of the screen and other params. */
  static void SetSize(int x,int y,char depth,BOOL Fullscreen);
  static void GetSize(int *w,int *h);

  /** Initialize the screen */
  static int Init();

  /** Destroy the screen and prepare it to exit */
  static int Shutdown();
  };

#endif
