#ifndef ARIANNE_Socket_H
#define ARIANNE_Socket_H

#include "general.h"
#include "mutex.h"
#include "templock.h"
#include <SDL/SDL_net.h>

/**
This class is a socket (TCP or UDP) abstraction.
By now it is using SDLnet, but later we could change it if needed.

Well this is a class that modelizes a Socket. We need to have the same
interface for both TCP and UDP.

I have been taking a look at the TCP/IP standard and using UDP will make
a real difference. But it can carry some problems as packets that get
lose or repeated.
**/

class Socket
  {
  static Uint32 NumSocketsOpen;

  IPaddress IP;
  Uint32 SocketBytesSent;
  Uint32 SocketBytesRecieved;

  Socket(Socket const&);
  Socket& operator=(Socket const&);
  Mutex mutex;

  public: 
  TCPsocket TCP;
  BOOL mError;

  Socket();
  ~Socket();

  void ResolveHost(char const* Server,Uint16 Port);
  char *ResolveIP();

  int Open();
  Socket *Accept();

  IPaddress *GetPeerAddress();

  Sint32 Send(void const* Data,Uint32 size_elem,Uint32 n_elems);
  Sint32 Recv(void *Data,Uint32 size_elem,Uint32 n_elems);
  void Close();
  BOOL isError();
  void SetError();

  Uint32 GetBytesSent();
  Uint32 GetBytesRecv();

  Uint32 ResetBytesSent();
  Uint32 ResetBytesRecv();
  };

#endif
