/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This class just create an structure to check if there is data
    awaiting on a socket.
***************************************************************************/
#include "SocketSet.h"
#include "Log.h"

SocketSet::SocketSet(int NumConnections)
  {
  assert(NumConnections>0);

  socketset=SDLNet_AllocSocketSet(NumConnections);
  }

SocketSet::~SocketSet()
  {
  SDLNet_FreeSocketSet(socketset);
  }

void SocketSet::Add(Socket *s)
  {
  if(s->isError()==TRUE)
    {
    /* Aborting. Severe error found */
    Log::Warning("Calling with a bad socket.%i",__LINE__);
    return;
    }

  SDLNet_TCP_AddSocket(socketset,s->TCP);
  }

void SocketSet::Del(Socket *s)
  {
  SDLNet_TCP_DelSocket(socketset,s->TCP);
  }

void SocketSet::Check(Uint32 timeout)
  {
  SDLNet_CheckSockets(socketset,timeout);
  } 

BOOL SocketSet::isReady(Socket *s)
  {
/*  if(s->isError()==TRUE)
    {
    return FALSE;
    }
*/
  if(SDLNet_SocketReady(s->TCP))
    {
    return TRUE;
    }

  return FALSE;
  }
