/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This an abstraction of a tile.

    It can be of whatever size you want. You only specify the a 3D point
    and the size.

    There should be a rendered that is the one that need to do a net with 
    the list of points that we give to it.

    The texture Index is the one that tell you what GFX to use.
    The flags can be use later for events related to it.
***************************************************************************/
#include "Terrain.h"

Uint16 Terrain::GetSize()
  {
  return x1.GetSize()+y1.GetSize()+z1.GetSize()+sizex.GetSize()+sizey.GetSize()+
         sizez.GetSize()+Flags.GetSize()+TextureIndex.GetSize();
  }

void Terrain::ToVector(AVector *vector)
  {
  assert(vector!=NULL);
   
  x1.ToVector(vector);
  y1.ToVector(vector);
  z1.ToVector(vector);
  sizex.ToVector(vector);
  sizey.ToVector(vector);
  sizez.ToVector(vector);
  Flags.ToVector(vector);
  TextureIndex.ToVector(vector);
  }

void Terrain::FromVector(AVector *vector)
  {
  assert(vector!=NULL);
   
  x1.FromVector(vector);
  y1.FromVector(vector);
  z1.FromVector(vector);
  sizex.FromVector(vector);
  sizey.FromVector(vector);
  sizez.FromVector(vector);
  Flags.FromVector(vector);
  TextureIndex.FromVector(vector);
  }

/** 
Returns TRUE if it is inside of the Box, that has inifinte Z axis lenght
**/
BOOL Terrain::isInside(Uint32 x1,Uint32 y1,Uint32 x2,Uint32 y2)
  {
  if((this->x1>=x1)&&(this->x1+sizex<=x2))
    {
    if((this->y1>=y1)&&(this->y1+sizey<=y2))
      {
      return TRUE;
      }
    }
  return FALSE;
  }

Terrain *Terrain::Clone()
  {
  Terrain *tmp=new Terrain;

  tmp->x1=x1;
  tmp->y1=y1;
  tmp->z1=z1;

  tmp->sizex=sizex;
  tmp->sizey=sizey;
  tmp->sizez=sizez;

  tmp->Flags=Flags;
  tmp->TextureIndex=TextureIndex;

  return tmp;
  }