#ifndef ARIANNE_TERRAIN_H 
#define ARIANNE_TERRAIN_H

#include "general.h"


/** Generic terrain representation 
   Terrain should no overlap itself so there is a unique piece of terrain that 
   has x1,y1,z1 as the upper left point*/
class Terrain: public Disposable
  {
  public:
  AUint32 x1,y1,z1;

  AUint16 sizex;
  AUint16 sizey;
  AUint16 sizez;

  AUint8 Flags;

  AUint8 TextureIndex;

  Uint16 GetSize();
  void ToVector(AVector *vector);
  void FromVector(AVector *vector);

  /** Returns true if the piece is inside the box defined by (x1,y1)-(x2,y2) */
  BOOL isInside(Uint32 x1,Uint32 y1,Uint32 x2,Uint32 y2);

  Terrain *Clone();
  };

#endif