#ifndef ARIANNE_TypeMemoryManager_H
#define ARIANNE_TypeMemoryManager_H

#include "general.h"
#include "AList.h"

template <class Type>
class TypeMemoryManager
  {
  AList<Type> *FreeArray;
  AList<Type> *BusyArray;
  Mutex m_mutex;


  public:
  TypeMemoryManager(Uint16 Num=4)
    {
    BusyArray=new AList<Type>;
    FreeArray=new AList<Type>;
    for(int i=0;i<Num;i++)
      {
      FreeArray->Add(new Type());
      }
    }
  
  ~TypeMemoryManager()
    {
    delete BusyArray;
    delete FreeArray; 
    }

  Type *GetNew()
    {
    TempLock lock(m_mutex);
 
    if(FreeArray->Size()>0)
      {
      Type *tmp=FreeArray->Remove(FreeArray->Size()-1);
      BusyArray->Add(tmp);
      return tmp;
      }
  
    throw "Not enough memory";
    return NULL;
    } 

  void ReleaseNew(Type *object)
    {
    TempLock lock(m_mutex);

    for(int i=0;i<BusyArray->Size();i++)
      {
      if((*BusyArray)[i]==object)
        {
        Type *tmp=BusyArray->Remove(i);
        FreeArray->Add(tmp);
        return;
        }
      }
  
    throw "Releasing a wrong object";
    }   
  };

#endif