/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This class get two list, one with the actual objects and other with
    the desired object state, and the class slowly update it to give a 
    feeling of fast update.
***************************************************************************/
#include "UpdateWorld.h"

UpdateWorld::UpdateWorld(Uint16 TimeUpdate)
  {
  this->TimeUpdate=TimeUpdate;
  }

UpdateWorld::~UpdateWorld()
  {
  }

void UpdateWorld::Update(AList<Object> *Actual,AList<Object> *Desired,Uint32 TimeSinceLastUpdate)
  {
  AList<Object> *tmpList=new AList<Object>;
  bool Found=false;

  /* We expect a list of objects */
  for(Uint32 i=0;i<Desired->Size();i++)
    {
    Found=false;
    Object *tmpDesired=(Object *)((*Desired)[i]);

    for(Uint32 j=0;(j<Actual->Size())&&(Found==false);j++)
      {
      if(((Object *)((*Actual)[j]))->mID==tmpDesired->mID)
        {
        Found=true;
        Object *tmpActual=(Object *)((*Actual)[j]);

        float PercentUpdate=(float)(TimeSinceLastUpdate)/(float)TimeUpdate;
        if(PercentUpdate>1) 
          {
          PercentUpdate=1;
          }

        Uint32 x1,y1,z1,x2,y2,z2;
        tmpActual->Pos.GetXYZ(&x1,&y1,&z1);
        tmpDesired->Pos.GetXYZ(&x2,&y2,&z2);

        tmpActual->Pos.MoveTo(x1+(Uint32)((x2-x1)*PercentUpdate),
                              y1+(Uint32)((y2-y1)*PercentUpdate),
                              z1+(Uint32)((z2-z1)*PercentUpdate));

        tmpList->Add(tmpActual,0);
        Actual->Remove(j);
        break;
        }
      }

    if(Found==false)
      {
      /* The object isn't in actual, we add it. */
      tmpList->Add(tmpDesired,0);
      }
    }

  Actual->Clear();
  for(Uint32 k=0;k<tmpList->Size();k++)   
    {
    Actual->Add((*tmpList)[k],0);
    }

  tmpList->Clear();
  delete tmpList;
  }

