#ifndef __ARIANNE_RPG_World_h
#define __ARIANNE_RPG_World_h

#include "general.h"
#include "List.h"
#include "MapObject.h"
#include "MapTerrain.h"
#include "Object.h"
#include "WorldManagers.h"


/**
This class store the World. Obviously this class have to change as soon as we 
go forward in the massive game experience.
**/
class World
  {
  MapObjects *mapObjects;
  MapTerrains *mapTerrains;
  AList<WorldManagers> *ListWorlds;

  public:
  World();
  ~World();

  BOOL LoadWorld(AString DataPath,AString FileName);
  BOOL SetWorld(AString DataPath,AString FileName);
  BOOL SaveWorld(AString DataPath,AString FileName);

  void ClearObjects();
  void ClearTerrains();

  AList<Object> *GetListObjects();
  AList<Terrain> *GetListTerrains();

  void UpdateTerrain(Terrain *terrain);
  void UpdateObject(Object *object);

  AList<Terrain> *isInRange(Uint32 x1,Uint32 y1,Uint32 x2,Uint32 y2);
  AList<Object> *isInRange(Position& Center, Uint32 Range);

  Object *GetObject(Uint32 uID);
  Object *GetObject(Object *object);
  void AddObject(Object *object);
  void RemoveObject(Object *object);
  void RemoveObject(Uint32 uID);

  Uint32 GetNumObjects();
  Uint32 GetNumTerrains();

  void AddWorldManagers(WorldManagers *wm);
  void RemoveWorldManagers(Uint32 i);
  Uint32 SizeWorldManagers();
  WorldManagers *GetWorldManagers(Uint32 i);

  void CallWorldManagers();
  void GetSize(Uint32 *x1,Uint32 *y1,Uint32 *x2,Uint32 *y2);
  };
  

#endif