/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
***************************************************************************/
#include "WorldManagers.h"
#include "Log.h"

WorldManagers::WorldManagers(AString& NameOfManager) 
  {
  this->NameOfManager=NameOfManager;
  Objects=new AList<Object>;
  }

WorldManagers::~WorldManagers()
  {
  delete Objects;
  }

void WorldManagers::LoadManager(AString DataPath)
  {
  Log::Warning("Calling a virtual function.");
  }

void WorldManagers::SaveManager(AString DataPath)
  {
  Log::Warning("Calling a virtual function.");
  }
  
void WorldManagers::Animate(World *world)
  {
  Log::Warning("Calling a virtual function.");
  }

AString WorldManagers::GetInfo()
 {
 return NameOfManager;
 }

Object *WorldManagers::GetObject(Uint32 uID)
  {
  for(Uint32 i=0;i<Objects->Size();i++)
    {
    Object *tmp=(*Objects)[i];
    if(tmp->mID==uID)
      {
      return tmp;
      }
    }
  
  return NULL;
  }

void WorldManagers::AddObject(Object *object)
  {
  assert(object!=NULL);

  Objects->Add(object);
  }


void WorldManagers::RemoveObject(Object *object)
  {
  assert(object!=NULL);

  for(Uint32 i=0;i<Objects->Size();i++)
    {
    Object *tmp=(*Objects)[i];
    if(tmp->mID==object->mID)
      {
      Objects->Free(i);
      return;
      }
    }

  return;
  }

void WorldManagers::RemoveObject(Uint32 uID)
  {
  for(Uint32 i=0;i<Objects->Size();i++)
    {
    Object *tmp=(*Objects)[i];
    if(tmp->mID==uID)
      {
      Objects->Free(i);
      return;
      }
    }

  return;
  }

