/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* common/astring.cpp

Project : Arianne RPG
Created : 2 Jul 2000

Simple string class without bells and whistles.

*/

#include "astring.h"
// Minami's addition -- do not #include "malloc.h" on Mac
#ifndef macintosh
#include "malloc.h"
#endif
#include "string.h"
#include <cstdarg>

void AString::assign(const char *newvalue)
{
/*    if (value) free(value);

    value=(newvalue) ? strdup(newvalue) : NULL;*/
    if( value ) delete[] value;
    if( newvalue )
    {
    	value = new char[strlen( newvalue ) + 1];
    	strcpy( value, newvalue );
    }
    else
    	value = NULL;
}

AString::AString(AString const& original):
    value(0)
{
    assign(original);
}

AString::AString(const char *initvalue):
    value(0)
{
    assign(initvalue);
}

AString::AString(const char *head, const char *tail):
    value(0)
{
    if (head) {
        if (tail) {
            value=(char *)malloc(strlen(head)+strlen(tail)+1);
            strcpy(value,head);
            strcat(value,tail);
        } else assign(head);
    } else assign(tail);
}
/** TODO: determine the string-length while constructing the content to prevent
    writing past the end of the array
*/
AString AString::Format(char const* fmt, ...)
{
    va_list ap;

    char str[1000];
    va_start(ap, fmt);
    vsprintf(str, fmt, ap);
    va_end(ap);

    return AString(str);
}

AString& AString::operator+= (const char *newtail)
{
    if (newtail!=NULL && *newtail!=NUL) {
        if (value) {
            //char *tempval=(char *)malloc(strlen(value)+strlen(newtail)+1);
            char* tempval = new char[ strlen( value ) + strlen( newtail) + 1 ];
            strcpy(tempval,value);
            strcat(tempval,newtail);
            //char *t2=value;
            delete value;
            value=tempval;
            //free(t2);
        } else assign(newtail);
    }
    return *this;
}

char * AString::str(void)
{
    //return strdup(value);
    char* cp = new char[ strlen(value ) + 1];
    strcpy( cp, value );
    return cp;
}