#ifndef ARIANNE_DEFINE_H
#define ARIANNE_DEFINE_H

//#define NO_EXCEPTIONS

/* Define the number of characters */
#define NUM_TILES_CHARA   59
#define NUM_TILES_TERRAIN 2

/* Define some propierties of AList */
#define MAX_ALIST_SIZE  (1<<24) /* 2^24 */
#define KEEP_SORT_LIST
#define OBJECT_BUFFER   256

/* Define some propierties of AVector */
#define EXTRA_MEM_USAGE 25

/* Define some propierties of Bzip2 Compressor */
#define BUFFER_SIZE 4096

/* Comment this to use ESC key to end */
#define TIME_LIMIT 30000

/* Type of Message sent */
#define RAW_DATA              1
#define BZIP2_COMPRESSED_DATA 2
#define ZIP_COMPRESSED_DATA   3

/* Uncomment to see the top frame rate on text mode */
//#define MAXIMUM_SPEED

/* Uncomment to work on Text mode */
//#define ARIANNE_TEXT_ONLY

/* Disable renderer */
//#define ARIANNE_NO_RENDERER

/* Number of connections per set. */
#define MAX_CONNECTIONS_PER_SET 32

/* Define the maximum number of players per server */
#define MAX_CONNECTIONS_PER_SERVER 32

/* Controls the speed of the animations */
#define ANIMATION_MSECONDS_PER_FRAME 250
#define FRAME_RATE 4 
#define RANGE_INFINITY (~(Uint32)0)

/* These are the lapsus of milliseconds between reports */
#define REPORT_TIME  10000
#define TIMEOUT_TIME 30000

/* For stop the server of hogging the CPU. */
#define SLEEP_TIME   10

#define SOCKET_RELATED_ERROR 2

#define MESSAGES_TYPE_NUMBER   5

#define ARIANNE_ADMIN                  0 
  #define ARIANNE_LOGIN                0
  #define ARIANNE_LOGOUT               1
  #define ARIANNE_SYNCHRONISM          2
  #define ARIANNE_SYSTEM_INFO          3

#define ARIANNE_CRASH_INFO             1
  #define ARIANNE_INFO_ABOUT_GAME      0

#define ARIANNE_CHARACTER_MANAGEMENT   2
  #define ARIANNE_LOAD_CHARACTER       0

#define ARIANNE_GAME                   3
  #define ARIANNE_ACTION               0
  #define ARIANNE_PERCEPTION           1

#define ARIANNE_MAP_RULES              4
  #define ARIANNE_MAP_PIECE            0

#define ARIANNE_realtime               0


#define ACTIONS_TYPE_NUMBER            2
#define ARIANNE_CHAT                   0
#define ARIANNE_MOVE                   1


#endif