/* common/general.h

Project : Arianne RPG
Created : 26 Jun 2000

Declare all globally used types, constants, macros and variables.
Handle as much as possible platform and compiler compatibility.

*/

#ifndef __ARIANNE_GENERAL_H
#define __ARIANNE_GENERAL_H
#ifndef __cplusplus
#error C++ compiler required.
#endif

#include "defines.h"

#include <SDL/SDL.h>
#ifndef macintosh
#include <SDL/SDL_net.h>
#else
#include "SDL_net.h"		// Mac version of SDL_net needed. I want it to be in user path.
#endif
#include <stdlib.h>
#include "Version.h"

#include <assert.h>

#ifndef DEBUG
#define DEBUG
#endif

#if defined(_Windows) || defined(__WIN32__) || defined(WIN32)
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#if defined(machintosh)
#define MACOS
#endif

/*
#ifndef macintosh
#define THREADLESS		// Sorry, I've added Mac specific thread implementation...!
#endif
*/

#include <stddef.h>
// Minami's change
#ifndef macintosh
#include <sys/types.h>	// This is the original
#else
#include <cstring>
#include "MacSupport.h"
#endif
// end of change

#ifndef FALSE
#define FALSE (0)
#endif

#ifndef TRUE        // Under Windows, BOOL is defined and is an Uint32
#define TRUE (1)
#endif

#ifndef BOOL
#define BOOL Uint8
#endif

#include "Tda.h"

#ifndef NULL
#define NULL ((void *)0)
#endif

#ifndef NUL
#define NUL ((char)0)
#endif

class Disposable {
public:
    virtual ~Disposable() { /* Derived destructor will be called */ };
};

// A single module will allocate global variables by #defining EXTVAR
// before including general.h - for all others it will be extern
#ifndef EXTVAR
#define EXTVAR extern
#define EXTVAL(t,n,v) extern t n
#else
#define EXTVAL(t,n,v) t n = (v)
#endif

EXTVAL(int,g_debugLevel,0);

#define TEST_GUI_MINAMI

#endif // __ARIANNE_GENERAL_H
