/***************************************************************************
                          mutex.cpp  -  description
                             -------------------
    begin                : Sat Jun 24 2000
    copyright            : (C) 2000 by Ulrich Eckhardt
    email                : Doomster@knuut.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This a mutex implementation class.

    I think that it don't run between threads as expected.
***************************************************************************/

#include "mutex.h"

#include <iostream>
using std::cerr;
#include <SDL/SDL_mutex.h>

Mutex::Mutex(bool locked):
	m_SDLMutex(SDL_CreateMutex())
{
#ifndef macintosh
	if(! m_SDLMutex)
		throw;
	if(locked)
		lock();
#endif
}
Mutex::~Mutex()
{
#ifndef macintosh
	SDL_DestroyMutex(m_SDLMutex);
#endif
}
int Mutex::lock()
{
#ifndef macintosh
	return SDL_LockMutex(m_SDLMutex);
#endif
}
int Mutex::unlock()
{
#ifndef macintosh
	return SDL_UnlockMutex(m_SDLMutex);
#endif
}