/***************************************************************************
                          templock.h  -  description
                             -------------------
    begin                : Sat Jun 24 2000
    copyright            : (C) 2000 by Ulrich Eckhardt
    email                : Doomster@knuut.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TEMPLOCK_H
#define TEMPLOCK_H

#include "general.h"
#include "mutex.h"

//class Mutex;

/**RAII-class: locks a mutex and unlocks with the destructor call
  *@author Ulrich Eckhardt
  */
class TempLock
{
public:
	/** beware: this 'const' is only faked, it will in fact lock the mutex */
	TempLock(Mutex const& mutex);
	virtual ~TempLock();
private:
	Mutex& m_mutex;
};

#endif
