#include <strings.h>

#include <stdlib.h>





void GenerateHeaderFile(char *MessageName)

  {

  FILE *Handle;

  char File[256];

  Descriptor *tmp;

  

  strcpy(File,"Action_");

  strcat(File,MessageName);

  strcat(File,".h");

  

  Handle=fopen(File,"wt");

  if(Handle==NULL)

    {

	fprintf(stderr,"File can't be open\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

	exit(1);

	}



  fprintf(Handle,"#ifndef ARIANNE_%s_h\n",MessageName);

  fprintf(Handle,"#define ARIANNE_%s_h\n",MessageName);

  fprintf(Handle,"\n");

  fprintf(Handle,"#include \"../general.h\"\n");

  fprintf(Handle,"#include \"../Action.h\"\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"class Action_%s: public Disposable\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  static Uint16 sType;\n");

  fprintf(Handle,"  Uint32 SourceID;\n");

  fprintf(Handle,"  Uint32 TargetID;\n");

  fprintf(Handle,"  Uint32 x,y,z;\n");

  

  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  %s %s;\n",tmp->type,tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"\n");

  fprintf(Handle,"  public:\n");

  fprintf(Handle,"  Action_%s();\n",MessageName);

  fprintf(Handle,"  ~Action_%s();\n",MessageName);

  fprintf(Handle,"  Action *ToGeneric();\n");

  fprintf(Handle,"  void FromGeneric(Action *Data);\n");

  fprintf(Handle,"  Uint16 GetSize();\n");

  fprintf(Handle,"\n");



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  void Set%s(%s %s);\n",tmp->name,tmp->type,tmp->name);

    fprintf(Handle,"  %s Get%s();\n",tmp->type,tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"  void SetSourceID(Uint32 SourceID);\n");

  fprintf(Handle,"  Uint32 GetSourceID();\n");

  fprintf(Handle,"  void SetTargetID(Uint32 TargetID);\n");

  fprintf(Handle,"  Uint32 GetTargetID();\n");

  fprintf(Handle,"  void SetXYZ(Uint32 x,Uint32 y,Uint32 z);\n");

  fprintf(Handle,"  void GetXYZ(Uint32 *x,Uint32 *y,Uint32 *z);\n");

  fprintf(Handle,"  };\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"#endif\n");

  fclose(Handle);

  }



void GenerateStaticVariable(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Uint16 Action_%s::sType=ARIANNE_%s;\n",MessageName,FindTypeName());

  fprintf(Handle,"\n");

  }





void GenerateConstructor(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Action_%s::Action_%s()\n",MessageName,MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"\n");

  }



void GenerateDestructor(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Action_%s::~Action_%s()\n",MessageName,MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"\n");

  }



void GenerateMessageFunctions(char *MessageName,FILE *Handle)

  {

  Descriptor *tmp;  



  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method return an array of chars\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"Action * Action_%s::ToGeneric()\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  Action *tmp=new Action;\n");

  fprintf(Handle,"  tmp->SourceID=SourceID;\n");

  fprintf(Handle,"  tmp->TargetID=TargetID;\n");

  fprintf(Handle,"  tmp->x=x;\n");

  fprintf(Handle,"  tmp->y=y;\n");

  fprintf(Handle,"  tmp->z=z;\n");

  fprintf(Handle,"  tmp->TypeAction=sType;\n");



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  %s.ToVector(tmp->Data);\n",tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"  return tmp;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method fill the object with data from an array of chars\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"void Action_%s::FromGeneric(Action *action)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  SourceID=action->SourceID;\n");

  fprintf(Handle,"  TargetID=action->TargetID;\n");

  fprintf(Handle,"  x=action->x;\n");

  fprintf(Handle,"  y=action->y;\n");

  fprintf(Handle,"  z=action->z;\n");



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  %s.FromVector(action->Data);\n",tmp->name);

    tmp=FindNextVariable();

    }

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"Uint16 Action_%s::GetSize()\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  return\n");

  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle," %s.GetSize()+",tmp->name);

    tmp=FindNextVariable();

    }

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  }





void GenerateVariableFunctions(char *MessageName,FILE *Handle)

  {

  Descriptor *tmp;



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"void Action_%s::Set%s(%s %s)\n",MessageName,tmp->name,tmp->type,tmp->name);

    fprintf(Handle,"  {\n");

    fprintf(Handle,"  this->%s=%s;\n",tmp->name,tmp->name);

    fprintf(Handle,"  }\n");

    fprintf(Handle,"  \n");

    fprintf(Handle,"%s Action_%s::Get%s()\n",tmp->type,MessageName,tmp->name);

    fprintf(Handle,"  {\n");

    fprintf(Handle,"  return %s;\n",tmp->name);

    fprintf(Handle,"  }\n");

    fprintf(Handle,"  \n");

    tmp=FindNextVariable();

    }



  fprintf(Handle,"void Action_%s::SetSourceID(Uint32 SourceID)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  this->SourceID=SourceID;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"Uint32 Action_%s::GetSourceID()\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  return SourceID;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"void Action_%s::SetTargetID(Uint32 TargetID)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  this->TargetID=TargetID;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"Uint32 Action_%s::GetTargetID()\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  return TargetID;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"void Action_%s::SetXYZ(Uint32 x,Uint32 y,Uint32 z)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  this->x=x;\n");

  fprintf(Handle,"  this->y=y;\n");

  fprintf(Handle,"  this->z=z;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"void Action_%s::GetXYZ(Uint32 *x,Uint32 *y,Uint32 *z)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  x[0]=this->x;\n");

  fprintf(Handle,"  y[0]=this->y;\n");

  fprintf(Handle,"  z[0]=this->z;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  }



void GenerateSourceFile(char *MessageName)

  {

  FILE *Handle;

  char File[256];



  strcpy(File,"Action_");

  strcat(File,MessageName);

  strcat(File,".cpp");



  Handle=fopen(File,"wt");

  if(Handle==NULL)

    {

    fprintf(stderr,"File can't be open\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

    exit(1);

    }



  fprintf(Handle,"#include \"Action_%s.h\"\n",MessageName);

  fprintf(Handle,"\n");



  GenerateStaticVariable(MessageName,Handle);

  GenerateConstructor(MessageName,Handle);

  GenerateDestructor(MessageName,Handle);

  GenerateMessageFunctions(MessageName,Handle);

  GenerateVariableFunctions(MessageName,Handle);



  fclose(Handle);

  }





void GenerateClassFromMessage()

  {

  char *MessageName;

  /* We need to create the class definition from the Message. */

  /* We look for the Name of the Message */



  MessageName=FindMessageName();

  if(MessageName==NULL)

    {

    fprintf(stderr,"Bad Grammar\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

    exit(1);

    }



  /* We first create the H file that define the class. */

  GenerateHeaderFile(MessageName);

  GenerateSourceFile(MessageName);

  }

