#include <strings.h>

#include <stdlib.h>





void GenerateHeaderFile(char *MessageName)

  {

  FILE *Handle;

  char File[256];

  Descriptor *tmp;

  

  strcpy(File,MessageName);

  strcat(File,".h");



  Handle=fopen(File,"wt");

  if(Handle==NULL)

    {

	fprintf(stderr,"File can't be open\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

	exit(1);

	}



  fprintf(Handle,"#ifndef ARIANNE_%s_h\n",MessageName);

  fprintf(Handle,"#define ARIANNE_%s_h\n",MessageName);

  fprintf(Handle,"\n");

  fprintf(Handle,"#include \"../general.h\"\n");

  fprintf(Handle,"#include \"../MessageManager.h\"\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"class Message_%s: public Disposable\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  MessageManager *mMesMan;\n");

  fprintf(Handle,"  static char sType;\n");

  fprintf(Handle,"  static char sSubtype;\n");

  fprintf(Handle,"  static char sPriority;\n");

  fprintf(Handle,"  Uint32 ID;\n");

  

  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  %s %s;\n",tmp->type,tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"\n");

  fprintf(Handle,"  public:\n");

  fprintf(Handle,"  Message_%s(MessageManager *MesMan);\n",MessageName);

  fprintf(Handle,"  ~Message_%s();\n",MessageName);

  fprintf(Handle,"  char GetType() {return sType;};\n");

  fprintf(Handle,"  char GetSubtype() {return sSubtype;};\n");

  fprintf(Handle,"  char GetPriority() {return sPriority;};\n");

  fprintf(Handle,"  Uint16 GetSize();\n");

  fprintf(Handle,"  void ToVector(AVector *vector);\n");

  fprintf(Handle,"  void FromVector(AVector *Data);\n");

  fprintf(Handle,"  BOOL isEmpty(Uint32 ID=0);\n");

  fprintf(Handle,"  void Put(Uint32 ID=0);\n");

  fprintf(Handle,"  BOOL Get(Uint32 ID=0);\n");

  fprintf(Handle,"\n");



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  void Set%s(%s %s);\n",tmp->name,tmp->type,tmp->name);

    fprintf(Handle,"  %s Get%s();\n",tmp->type,tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"  };\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"#endif\n");

  fclose(Handle);

  }



void GenerateStaticVariable(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"char Message_%s::sType=%s;\n",MessageName,FindTypeName());

  fprintf(Handle,"\n");

  fprintf(Handle,"char Message_%s::sSubtype=%s;\n",MessageName,FindSubtypeName());

  fprintf(Handle,"\n");

  fprintf(Handle,"char Message_%s::sPriority=%s;\n",MessageName,FindPriorityName());

  fprintf(Handle,"\n");

  }





void GenerateConstructor(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Message_%s::Message_%s(MessageManager *MesMan)\n",MessageName,MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  this->mMesMan=MesMan;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"\n");

  }



void GenerateDestructor(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Message_%s::~Message_%s()\n",MessageName,MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"\n");

  }



void GenerateMessageFunctions(char *MessageName,FILE *Handle)

  {

  Descriptor *tmp;

  int first;



  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method test if there is a message of this type-subtype in the \n");

  fprintf(Handle,"MessageManager waiting to be processed.\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"BOOL Message_%s::isEmpty(Uint32 ID)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  return mMesMan->IsEmpty(sType,sSubtype,ID);\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method add a message to the MessageManager in order to be send.\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"void Message_%s::Put(Uint32 ID)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  /* We simply create a new generic Message and fill it using the next kind of\n");

  fprintf(Handle,"     data . */\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"  GenericMessage *GenMes=new GenericMessage();\n");

  fprintf(Handle,"  GenMes->ID=ID;\n");

  fprintf(Handle,"  GenMes->Type=this->GetType();\n");

  fprintf(Handle,"  GenMes->SubType=this->GetSubtype();\n");

  fprintf(Handle,"  GenMes->Length=this->GetSize();\n");

  fprintf(Handle,"  this->ToVector(GenMes->Data);\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"  /* Now we add this to the OutMessage queue */\n");

  fprintf(Handle,"  Queue *tmp=mMesMan->GetQueue(sType);\n");

  fprintf(Handle,"  if(tmp!=NULL)\n");

  fprintf(Handle,"    {\n");

  fprintf(Handle,"    tmp->AddOutMessage(GenMes);\n");

  fprintf(Handle,"    return;\n");

  fprintf(Handle,"    }\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"  /* We have a message that hasn't any of the known types. */\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method gets a message from the MessageManager and fill the variables\n");

  fprintf(Handle,"of this object with it.\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"BOOL Message_%s::Get(Uint32 ID)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  GenericMessage *GenMes;\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"  /* Now we add this to the OutMessage queue */\n");

  fprintf(Handle,"  Queue *tmp=mMesMan->GetQueue(sType);\n");

  fprintf(Handle,"  if(tmp!=NULL)\n");

  fprintf(Handle,"    {\n");

  fprintf(Handle,"    GenMes=tmp->GetInMessage(GetSubtype(),ID);\n");

  fprintf(Handle,"    if(GenMes!=NULL)\n");

  fprintf(Handle,"      {\n");

  fprintf(Handle,"      this->ID=GenMes->ID;\n");

  fprintf(Handle,"      this->FromVector(GenMes->Data);\n");

  fprintf(Handle,"      delete GenMes;\n");

  fprintf(Handle,"      return TRUE;\n");

  fprintf(Handle,"      }\n");

  fprintf(Handle,"    else\n");

  fprintf(Handle,"      {\n");

  fprintf(Handle,"      return FALSE;\n");

  fprintf(Handle,"      }\n");

  fprintf(Handle,"    }\n");

  fprintf(Handle,"  /* We have a message that hasn't any of the known types. */\n");

  fprintf(Handle,"  return FALSE;\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method returns the size of the Message data\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"Uint16 Message_%s::GetSize()\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  /* TODO: Implement here the GetSize Method */\n");

  fprintf(Handle,"  return ");



  tmp=FindVariable();

  first=0;

  while(tmp!=NULL)

    {

    if(first==0)

      {

      first=1;

      }

    else

      {

      fprintf(Handle,"+");

      }

    fprintf(Handle,"%s.GetSize()",tmp->name);

    tmp=FindNextVariable();

    }

  fprintf(Handle,";\n");



  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method return an array of chars\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"void Message_%s::ToVector(AVector *Vector)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  /* TODO: Implement here the ToVector Method */\n");



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  %s.ToVector(Vector);\n",tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method fill the object with data from an array of chars\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"void Message_%s::FromVector(AVector *Vector)\n",MessageName);

  fprintf(Handle,"  {\n");



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  %s.FromVector(Vector);\n",tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  }





void GenerateVariableFunctions(char *MessageName,FILE *Handle)

  {

  Descriptor *tmp;



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"void Message_%s::Set%s(%s %s)\n",MessageName,tmp->name,tmp->type,tmp->name);

    fprintf(Handle,"  {\n");

    fprintf(Handle,"  this->%s=%s;\n",tmp->name,tmp->name);

    fprintf(Handle,"  }\n");

    fprintf(Handle,"  \n");

    fprintf(Handle,"%s Message_%s::Get%s()\n",tmp->type,MessageName,tmp->name);

    fprintf(Handle,"  {\n");

    fprintf(Handle,"  return %s;\n",tmp->name);

    fprintf(Handle,"  }\n");

    fprintf(Handle,"  \n");

    tmp=FindNextVariable();

    }

  }



void GenerateSourceFile(char *MessageName)

  {

  FILE *Handle;

  char File[256];



  strcpy(File,MessageName);

  strcat(File,".cpp");



  Handle=fopen(File,"wt");

  if(Handle==NULL)

    {

    fprintf(stderr,"File can't be open\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

    exit(1);

    }



  fprintf(Handle,"#include \"%s.h\"\n",MessageName);

  fprintf(Handle,"\n");



  GenerateStaticVariable(MessageName,Handle);

  GenerateConstructor(MessageName,Handle);

  GenerateDestructor(MessageName,Handle);

  GenerateMessageFunctions(MessageName,Handle);

  GenerateVariableFunctions(MessageName,Handle);



  fclose(Handle);

  }





void GenerateClassFromMessage()

  {

  char *MessageName;

  /* We need to create the class definition from the Message. */

  /* We look for the Name of the Message */



  MessageName=FindMessageName();

  if(MessageName==NULL)

    {

    fprintf(stderr,"Bad Grammar\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

    exit(1);

    }



  /* We first create the H file that define the class. */

  GenerateHeaderFile(MessageName);

  GenerateSourceFile(MessageName);

  }

