%{

#define TOKEN_MESSAGE           257

#define TOKEN_ID                258

#define TOKEN_PRIORITY          259

#define TOKEN_DPERIOD           260

#define TOKEN_PCOMMA            261

#define TOKEN_COMMA             262

#define TOKEN_OPEN_BRACKETS     263

#define TOKEN_CLOSE_BRACKETS    264

#define TOKEN_NUMBER            265

#define TOKEN_TYPE              266

#define TOKEN_SUBTYPE           267

#define TOKEN_DEFS              268     

#define TOKEN_DATA              269

#define TOKEN_DPRIORITY         270





static unsigned int LineNumber=1;

%}



delim	        [ \t]

white_sp        {delim}+

nl	        [\n]

comment	        [\#]

letter	        [A-Za-z0-9\_\*]

digit	        [0-9]

id	        {letter}({letter}|{digit})*

number          {digit}+(\.{digit}+)?([Ee][+\-]?{digit}+)?



%%



<<EOF>>         {return (-1);}

{comment}.*

{delim}

{nl}		{LineNumber++;}

"\r"		

"Message"	{return TOKEN_MESSAGE;}

"ARIANNE_realtime"	{

                yylval.name=strdup(yytext);

                return TOKEN_PRIORITY;

                }

"high"		{

                yylval.name=strdup(yytext);

                return TOKEN_PRIORITY;

                }

"low"		{

                yylval.name=strdup(yytext);

                return TOKEN_PRIORITY;

                }

"cacheable"	{

                yylval.name=strdup(yytext);

                return TOKEN_PRIORITY;

                }

"type"          {

                return TOKEN_TYPE;

                }

"subtype"       {

                return TOKEN_SUBTYPE;

                }

"priority"      {

                return TOKEN_DPRIORITY;

                }

"defs"          {

                return TOKEN_DEFS;

                }                 

"data"          {

                return TOKEN_DATA;

                }

":"             {return TOKEN_DPERIOD;}

";"		{return TOKEN_PCOMMA;}

","		{return TOKEN_COMMA;}

"\{"		{return TOKEN_OPEN_BRACKETS;}

"\}"		{return TOKEN_CLOSE_BRACKETS;}

{number}        {

                yylval.value=atoi(yytext);

                return TOKEN_NUMBER;

                }

{id}		{

                yylval.name=strdup(yytext);

                return TOKEN_ID;

                }

. 		{

                printf("ERROR Line(%i): Unknown string \"%s\"\n",LineNumber,yytext);

                };



%%

/**

This manage the line number.

**/

int ActualLine()

  {

  return LineNumber;

  }



/**

The point of this file is to make a lexical analizer for scanning a text

to recognize our language to make a network byte level parser analizer for

Arianne.



NO WARRANTY.

Release under GPL license.



int main(int Num,char **arg)

  {

  int Returned=yylex();



  while(Returned>0)

    {

    printf("%s (TOKEN (%i))\n",yytext,Returned);

    Returned=yylex();

    }



  return 0;

  }

**/

