#include <strings.h>

#include <stdlib.h>





void GenerateHeaderFile(char *MessageName)

  {

  FILE *Handle;

  char File[256];

  Descriptor *tmp;

  

  strcpy(File,"Type_");

  strcat(File,MessageName);

  strcat(File,".h");

  

  Handle=fopen(File,"wt");

  if(Handle==NULL)

    {

	fprintf(stderr,"File can't be open\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

	exit(1);

	}



  fprintf(Handle,"#ifndef ARIANNE_%s_h\n",MessageName);

  fprintf(Handle,"#define ARIANNE_%s_h\n",MessageName);

  fprintf(Handle,"\n");

  fprintf(Handle,"#include \"../general.h\"\n");

  fprintf(Handle,"#include \"../Object.h\"\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"class Type_%s: public Disposable\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  static Uint16 sType;\n");

  

  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  %s %s;\n",tmp->type,tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"\n");

  fprintf(Handle,"  public:\n");

  fprintf(Handle,"  Type_%s();\n",MessageName);

  fprintf(Handle,"  ~Type_%s();\n",MessageName);

  fprintf(Handle,"  Object *ToGeneric();\n");

  fprintf(Handle,"  void FromGeneric(Object *Data);\n");

  fprintf(Handle,"  Uint16 GetSize();\n");

  fprintf(Handle,"\n");



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"  void Set%s(%s %s);\n",tmp->name,tmp->type,tmp->name);

    fprintf(Handle,"  %s Get%s();\n",tmp->type,tmp->name);

    tmp=FindNextVariable();

    }



  fprintf(Handle,"  };\n");

  fprintf(Handle,"\n");

  fprintf(Handle,"#endif\n");

  fclose(Handle);

  }



void GenerateStaticVariable(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Uint16 Type_%s::sType=%s;\n",MessageName,FindTypeName());

  fprintf(Handle,"\n");

  }





void GenerateConstructor(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Type_%s::Type_%s()\n",MessageName,MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"\n");

  }



void GenerateDestructor(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"Type_%s::~Type_%s()\n",MessageName,MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"\n");

  }



void GenerateMessageFunctions(char *MessageName,FILE *Handle)

  {

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method return an array of chars\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"Object * Type_%s::ToGeneric()\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  /* TODO: Implement here the ToGeneric Method */\n");

  fprintf(Handle,"  return NULL;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"/**\n");

  fprintf(Handle,"This method fill the object with data from an array of chars\n");

  fprintf(Handle,"**/\n");

  fprintf(Handle,"void Type_%s::FromGeneric(Object *Data)\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  fprintf(Handle,"Uint16 Type_%s::GetSize()\n",MessageName);

  fprintf(Handle,"  {\n");

  fprintf(Handle,"  /* TODO: Implement here the GetSize Method */\n");

  fprintf(Handle,"  return 0;\n");

  fprintf(Handle,"  }\n");

  fprintf(Handle,"  \n");

  }





void GenerateVariableFunctions(char *MessageName,FILE *Handle)

  {

  Descriptor *tmp;



  tmp=FindVariable();

  while(tmp!=NULL)

    {

    fprintf(Handle,"void Type_%s::Set%s(%s %s)\n",MessageName,tmp->name,tmp->type,tmp->name);

    fprintf(Handle,"  {\n");

    fprintf(Handle,"  this->%s=%s;\n",tmp->name,tmp->name);

    fprintf(Handle,"  }\n");

    fprintf(Handle,"  \n");

    fprintf(Handle,"%s Type_%s::Get%s()\n",tmp->type,MessageName,tmp->name);

    fprintf(Handle,"  {\n");

    fprintf(Handle,"  return %s;\n",tmp->name);

    fprintf(Handle,"  }\n");

    fprintf(Handle,"  \n");

    tmp=FindNextVariable();

    }

  }



void GenerateSourceFile(char *MessageName)

  {

  FILE *Handle;

  char File[256];



  strcpy(File,"Type_");

  strcat(File,MessageName);

  strcat(File,".cpp");



  Handle=fopen(File,"wt");

  if(Handle==NULL)

    {

    fprintf(stderr,"File can't be open\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

    exit(1);

    }



  fprintf(Handle,"#include \"Type_%s.h\"\n",MessageName);

  fprintf(Handle,"\n");



  GenerateStaticVariable(MessageName,Handle);

  GenerateConstructor(MessageName,Handle);

  GenerateDestructor(MessageName,Handle);

  GenerateMessageFunctions(MessageName,Handle);

  GenerateVariableFunctions(MessageName,Handle);



  fclose(Handle);

  }





void GenerateClassFromMessage()

  {

  char *MessageName;

  /* We need to create the class definition from the Message. */

  /* We look for the Name of the Message */



  MessageName=FindMessageName();

  if(MessageName==NULL)

    {

    fprintf(stderr,"Bad Grammar\nLINE: %i  FILE: %s\n",__LINE__,__FILE__);

    exit(1);

    }



  /* We first create the H file that define the class. */

  GenerateHeaderFile(MessageName);

  GenerateSourceFile(MessageName);

  }

