/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
***************************************************************************/

#include "../common/general.h"
#include "../common/Log.h"
#include "../common/Screen.h"
#include "../common/DataLoader.h"
#include "../client/parseCMDLine.h"

int main(int Num,char **arg)
  {
#ifdef macintosh
	freopen( "stderr.txt","w", stderr );
	freopen( "stdout.txt","w", stdout );
#endif
  if(SDL_Init(SDL_INIT_NOPARACHUTE)<0)
    {
    Log::Error("Can't init SDL library.\n");
    }
  atexit(SDL_Quit);

  parseCMDLine(Num,arg);
  DataLoader::Init(g_configFile);

  Screen::Init();
  Screen::SetSize(DataLoader::GetWidth(),DataLoader::GetHeight(),DataLoader::GetDepth(),DataLoader::GetFullscreen());

  Uint32 chrono_start,chrono_end;

  chrono_start=SDL_GetTicks();
  int i;

  for(i=0;i<1000;i++)
    {
    SDL_Flip(Screen::GetScreen());
    }

  chrono_end=SDL_GetTicks();
  float fps=(float)i/((float)(chrono_end-chrono_start)/1000.0f);
  printf("Frames rendered: %i  -- FPS: %f",i,fps);


  return 0;
  }

