/***************************************************************************

                          main.cpp  -  description

                             -------------------

    begin                : Tue Jul  4 19:37:43 CEST 2000

    copyright            : (C) 2000 by Ulrich Eckhardt

    email                : Doomster@knuut.de

 ***************************************************************************/



/***************************************************************************

 *                                                                         *

 *   This program is free software; you can redistribute it and/or modify  *

 *   it under the terms of the GNU General Public License as published by  *

 *   the Free Software Foundation; either version 2 of the License, or     *

 *   (at your option) any later version.                                   *

 *                                                                         *

 ***************************************************************************/



#include "../common/thread.cpp"

#include "../common/mutex.cpp"

#include "../common/templock.cpp"

#include <SDL/SDL_timer.h>

#include <iostream>

using std::cerr;

using std::endl;

class Test: public LoopThread

{

public:

	int count;

	Mutex m_mutex;

	Test():LoopThread(),count(0){};

	~Test(){};

	void loop()

	{

		TempLock lock(m_mutex);

		cerr << "ID:" << threadID() << " ,count = " << ++count << endl;

		SDL_Delay(400);

	}

};

int main(int argc, char *argv[])

{

	Test t1,t2;

	SDL_Delay(1000);

	cerr << "starting thread1\n";

	t1.start();

	SDL_Delay(1000);

	cerr << "starting thread2\n";

	t2.start();

	SDL_Delay(1000);

	cerr << "suspending thread1\n";

	t1.suspend();

	SDL_Delay(1000);

	cerr << "enter anything to continue" << endl;

	int s;

	cin >> s;

	cerr << "suspending thread2\n";

	t2.suspend();

	SDL_Delay(1000);

	cerr << "starting thread1\n";

	t1.start();

	cerr << "stopping thread2\n";

	t2.stop();

	SDL_Delay(1000);

	cerr << "stopping thread1\n";

	t1.stop();



	return 0;

}

