#ifndef ARIANNE_ReportGenerator_h
#define ARIANNE_ReportGenerator_h

#include "../common/general.h"
#include "../common/World.h"
#include "../common/DataLoader.h"
#include "../common/NetworkServerManager.h"

/**
Create a report of the actual state of the server.
**/
class ReportGenerator
  {
  AString StartUpTime;
  float SecondsSinceStart;
  Uint32 NumPlayersSinceStart;
  World *world;
  NetworkServerManager *netMan;
  Uint32 DataSent;
  Uint32 DataRecv;
  Uint32 ErrorsOnZombieCharacters;
  Uint32 NumPlayers;

  Uint32 OS_Linux;
  Uint32 OS_Windows;
  Uint32 OS_BeOS;
  Uint32 OS_MacOS;
  Uint32 OS_Unknown;

  AString ServerDescription;
  AString ServerIPAddress;

  public:
  ReportGenerator();
  ~ReportGenerator();
  void Show();
  void GenerateHTML();
  void IncTime(float time);
  void IncPlayersSinceStart();
  void SetWorld(World *world);
  void SetNetworkServerManager(NetworkServerManager *netMan);
  void SetErrorsOnZombieCharacters(Uint32 i);
  void SetNumPlayers(Uint32 i);

  void AddSystemInfoStats(AString OS,AString CPU,AString Mem);
  };

#endif
