/***************************************************************************
    copyright            : (C) 2000 by Miguel Angel Blanch Lardin
    email                : x5101920@fedro.ugr.es
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
    This class is the one that start all the server stuff.
***************************************************************************/

#include "../common/general.h"
#include "../common/Log.h"

#include "../common/NetworkServerInit.h"
#include "../common/CoreServer.h"

// Minami's addition
// This is for MacOS server
#ifdef macintosh
#include "server_mac.h"
#endif
// end of addition

#include <stdlib.h>
#include <stdio.h>
#include <time.h>

AString g_configFile="./Arianne.ini";


int main(int Num,char **arg)
{
#ifdef macintosh
	freopen( "stderr.txt","w", stderr );
	freopen( "stdout.txt","w", stdout );
#endif

  if(SDL_Init(SDL_INIT_NOPARACHUTE)<0)
    {
    Log::Error("Can't init SDL library.\n");
    }
  atexit(SDL_Quit);

  #ifndef NO_EXCEPTIONS
  try
  #endif
    {
        srand ((unsigned)time( NULL ) );
        DataLoader::Init(g_configFile);
  
        #ifdef macintosh
		initMacInterface();
		#endif
		
        Log::Debug("Begin Server %s",ARIANNE_HARDCODE_VERSION);

        NetworkServerInit *netInit=new NetworkServerInit();
        netInit->Init(NULL,DataLoader::GetHostPort());
        netInit->Run();

        CoreServer *coreServer=new CoreServer(netInit->GetMessageManager(),netInit->GetNetworkServerManager());
        coreServer->Run();

        netInit->Shutdown();

    }
  #ifndef NO_EXCEPTIONS
    catch(...)
    {
        std::cerr << "caught unknown exception" << std::endl;
    }
  #endif
    /* Makes your compiler happy. */
    return 0;
}

#ifdef macintosh

void
initMacInterface()
{
	Handle menuBar = ::GetNewMBar( MENU_BAR );
	if( ! menuBar )
		Log::Error( "Could not initialize menu bar" );
	::SetMenuBar( menuBar );
	Handle appleMenu = (Handle)::GetMenuHandle( APPLE_MENU );
	if( ! appleMenu )
		Log::Error( "Could not initialize apple menu");
	::AppendResMenu( (MenuInfo**)appleMenu, 'DRVR' );
	 
}

#endif